local RetManager = Class(function(self, inst)
    self.inst = inst

	self.basereach = -1.0 --HAS TO BE NEGATIVE
	self.reach = self.basereach
	
	self.basesize = 1
	self.size = self.basesize
	-- self.floorret
	
	-- self.floorret = SpawnPrefab("reticule")
	-- inst.floorret.AnimState:SetMultColour(1,1,1,0.5)
	
	
	
	self.floorbeam = SpawnPrefab("reticule") --A COPY OF THE RETICULE BUT ITS A BEAM OF LIGHT. ONLY AT FAR DISTANCES
	self.floorbeam.AnimState:SetMultColour(0,0,0,0) --DON'T SHOW IT YET. WE ARENT READY
	self.floorbeam.AnimState:SetOrientation(ANIM_ORIENTATION.Default ) --VANILLA DS CHANGE - THIS ONE IS CALLED DEFAULT
    self.floorbeam.AnimState:SetLayer(LAYER_WORLD)
    self.floorbeam.AnimState:SetSortOrder(0)
	self.floorbeam.AnimState:SetBank("background_image")
    self.floorbeam.AnimState:SetBuild("background_image")
    self.floorbeam.AnimState:PlayAnimation("lightbeam")
	
	--AND GIVE THE FLOORRET PHYSICS SO IT CAN MOTOR --NO NEVERMIND IT CANT
	-- self.inst.floorret.entity:AddPhysics()
	-- self.inst.floorret.Physics:SetMass(1)
	-- self.inst.floorret.Physics:SetFriction(0)
	-- self.inst.floorret.Physics:SetDamping(0)
	-- self.inst.floorret.Physics:SetRestitution(0)
	
	self.mouselock = false
	self.containeropened = false
	
	self.selfselecable = true
	
	--1-22  --FOR KEEPING TRACK OF OBJECTS TOO LARGE TO ENTER OUR NATURAL DETECTION RANGE
	self.spotlightent = nil
	self.spotlightdist = nil
	
	--FOR THE AUTO LOCK ON FEATURE
	self.combattarget = nil
	
	-- local oldbox = TheSim:FindFirstEntityWithTag("skybox")
	
	-- inst:DoTaskInTime(8, function()
		-- self.background = oldbox
	-- end)
	
	
	--THE SKYBOX
	self.background = SpawnPrefab("background")
	self.background.AnimState:SetLayer( LAYER_WORLD ) --LAYER_WORLD
	self.background.AnimState:PlayAnimation("smoothed") --LETS JUST SMOOTH EM ALL. WHY NOT
	self.background.r = 0.32
	self.background.g = 1 --0.42
	self.background.t = 1
	
	--2-8-17 I THINK IT MIGHT BE TIME WE RETIRED THESE
	--ACTUALLY, IM GONNA KEEP JUST THIS ONE TOO. BECAUSE IT LOOKS NICE WITH THE SKY
	self.backfog = SpawnPrefab("background")
	self.backfog.AnimState:SetLayer( LAYER_WORLD )
	self.backfog.AnimState:PlayAnimation("smoothed")
	self.backfog.r = 0.32 --82
	self.backfog.g = 0.92
	self.backfog.b = 1
	self.backfog.t = 0.1
	self.backfog.basetint = 0.4
	
	--[[
	self.backmist = SpawnPrefab("background") --I DONT... THINK THIS ONE WORKS...
	self.backmist.AnimState:SetLayer( LAYER_WORLD )
	self.backmist.AnimState:PlayAnimation("smoothed")
	self.backmist.basetint = 0.4
	self.backmist.t = 0.1
	]]
	
	
	
	
	
	--4-26-18 NEW SKY DECOR FEATURE. PUTTING IT IN A SPOT IT REALLY DOESN'T BELONG, BUT OH WELL. ITS CONVENIENT AND IM LAZY
	--------------------------------------------------------------------------------
	if SKY_DECOR == true then
		--CLOUD TEMPLATE GENERATOR
		local function SpawnCloud(cloud)
			cloud.AnimState:SetLayer( LAYER_WORLD )
			cloud.AnimState:SetBank("sky_decor") 
			cloud.AnimState:SetBuild("sky_decor")
			cloud.AnimState:PlayAnimation("cloud3")
			cloud.r = 1
			cloud.g = 1
			cloud.b = 1
			cloud.t = 0.4 --KEEPING THIS NUMBER LOW AS OPPOSED TO THE R VALUE ALLOWS IT TO DARKEN WITHOUT GOING RED AT DUSK
			cloud.basetint = 1
			local sizev = 5
			cloud.Transform:SetScale(sizev,sizev,sizev)
			
			--UPDATE THE CLOUDS DARKNESS WITH ANY DOWNCAST CAUSED BY WEATHER AND RAIN
			cloud:DoPeriodicTask(3, function()
				if not (GetSeasonManager() and GetSeasonManager():GetWeatherLightPercent()) then return end
				
				local moistureshade = self:GetMoistureShade()
				local tint = math.clamp((-0.75 + moistureshade) * 2, 0, 0.5) --4-26
				cloud.r = 1 - tint
				cloud.g = 1 - tint
				cloud.b = 1 - tint
				cloud.t = 0.4 + tint
			end)
			
		end
		
		
		-- 4-21-18 LETS TRY A CLOUD
		--I REALLY SHOULD HAVE CREATED A SEPERATE PREFAB INSTEAD OF USING BACKGROUND, CUZ THESE THINGS DO NOT CHANGE COLOR LIKE THE SKY DOES
		self.cloud1 = SpawnPrefab("background") 
		self.cloud2 = SpawnPrefab("background")
		self.cloud3 = SpawnPrefab("background")
		SpawnCloud(self.cloud1)
		SpawnCloud(self.cloud2)
		SpawnCloud(self.cloud3)
		--WE NEED TO UPDATE ALL SKY DECORATIONS IN THE SAME WAY WE UPDATE THE RETICLE, OTHERWISE THERE IS VERY NOTICEABLE STUTTERING
		
		--AND A MOON!
		self.moon = SpawnPrefab("background")
		self.moon.AnimState:SetLayer( LAYER_WORLD )
		self.moon.AnimState:SetBank("sky_decor") --nitre
		self.moon.AnimState:SetBuild("sky_decor")
		self.moon.AnimState:PlayAnimation("moonsmall") --moon
		self.moon.r = 1
		self.moon.g = 1
		self.moon.b = 1
		self.moon.t = 0
		self.moon.basetint = 1
		self.moon.inverselight = true
		self.moon:AddComponent("colourtweener")
		local sizev = 8
		self.moon.Transform:SetScale(sizev,sizev,sizev)
		self.moon:DoPeriodicTask(3, function()
			if GetClock():IsNight() then --ONLY TURN ON AT NIGHT
				self.moon.basetint = 1
				self.moon.r = 1
				self.moon.g = 1
				self.moon.b = 1
			else
				self.moon.basetint = 0.7
				self.moon.r = 0
				self.moon.g = 0
				self.moon.b = 0
			end
		end)
		
		
		--OKAY, HOW ABOUT A SUN?
		self.sun = SpawnPrefab("background")
		self.sun.AnimState:SetLayer( LAYER_WORLD )
		self.sun.AnimState:SetBank("sky_decor") --nitre
		self.sun.AnimState:SetBuild("sky_decor")
		self.sun.AnimState:PlayAnimation("sun")
		self.sun.r = 1
		self.sun.g = 1
		self.sun.b = 1
		self.sun.t = 0
		self.sun.basetint = 1
		self.sun:AddComponent("colourtweener")
		local sizev = 5
		self.sun.Transform:SetScale(sizev,sizev,sizev)
		

		--AT DUSK, PLAY THE SUNSET
		GetWorld():ListenForEvent("dusktime", function()
			self.sun:DoTaskInTime(3, function()
				self.sun.AnimState:PlayAnimation("sunset")
				self.sun.components.colourtweener:StartTween({ 0,0,0,0 }, 90 * FRAMES)
				self.sun:DoTaskInTime(3, function()
					self.sun.basetint = 0
					self.sun.r = 0
					self.sun.g = 0
					self.sun.b = 0
				end)
			end)
		end)
		
		--AT DAY, SUNRISE
		GetWorld():ListenForEvent("daytime", function()
			self.sun:DoTaskInTime(1, function()
				self.sun.AnimState:PlayAnimation("sunrise")
				if not self.sun.pausecolorshift == true then --4-26 MAKE SURE THESE DONT BECOME VISIBLE IN 3RD PERSON
					self.sun.components.colourtweener:StartTween({ 1,1,1,1 }, 90 * FRAMES)
				end
				self.sun:DoTaskInTime(3, function()
					self.sun.basetint = 1
					self.sun.r = 1
					self.sun.g = 1
					self.sun.b = 1
				end)
			end)
			self.moon.AnimState:PlayAnimation("moonsmall") --THIS DOESN'T SHOW THE MOON, JUST SETS THE ANIMATION FOR WHEN IT SHOWS UP
		end)
		
		--THE MOON DOESNT GET RISE/FALL ANIMATIONS BECAUSE I SAID SO. ITS LESS IMPORTANT
		GetWorld():ListenForEvent("nighttime", function()
			if not self.moon.pausecolorshift == true then --4-26 MAKE SURE THESE DONT BECOME VISIBLE IN 3RD PERSON
				self.moon.components.colourtweener:StartTween({ 1,1,1,1 }, 60 * FRAMES)
			end
			-- (GetClock():GetMoonPhase() and (GetClock():GetMoonPhase() == "full"))
		end)
		
		GetWorld():ListenForEvent("fullmoon", function()
			self.moon.AnimState:PlayAnimation("fullmoonrise")
		end)
	end
	------------------------------------------------
	
	
	
	--SKYBOX IS NOWHERE TO BE FOUND WHEN WE FIRST SPAWN IN!! DO A QUICK CHECK TO FIND US AND SET IT RIGHT IN FRONT OF US
	local x, y, z = self.inst.Transform:GetWorldPosition()
	self.background.Transform:SetPosition( x + 5, 0.2,  z+5)
	self.backfog.Transform:SetPosition( x + 5, 0.2,  z+5) --YOU TOO
	
	
	
	--12-8-18 HAMLET CHANGE - AFTER A FEW HAMLET CHANGES TO PREVENT SKYBOXES IN BUILDINGS, SKBOX IS ... STILL... NOWHERE TO BE FOUND WHEN WE SPAWN IN
	-- CHECK FOR THE TIME OF DAY AND MANUALLY SET THE SCENE WHEN WE WALK IN
 
	--IF WE START THE GAME, WE HAVE TO BE ABLE TO KNOW IF WE ARE INDOORS OR NOT!!
	--TAKE A LOOK AROUND. ARE THERE ANY DOORS NEARBY? IF THERE ARE, CHANCES ARE, WE'RE INSIDE
	for k,v in pairs(TheSim:FindEntities(x,  y,  z,  20, {"interior_door"})) do  --(all)(none)(any)
		TheCamera.interior = true
		print("DOORS FOUND")
	end
	
	self.background:DoTaskInTime(1, function()
		--TAKE A LOOK AROUND. ARE THERE ANY DOORS NEARBY? IF THERE ARE, CHANCES ARE, WE'RE INSIDE
		local x, y, z = self.inst.Transform:GetWorldPosition()
		for k,v in pairs(TheSim:FindEntities(x,  y,  z,  20, {"interior_door"})) do  --(all)(none)(any)
			TheCamera.interior = true
			print("DOORS FOUND")
		end
		
		if (GetClock():IsDay() or GetClock():IsDusk()) and (GetWorld().components.interiorspawner and TheCamera.interior == false) then
			
			-- print("WHERE ARE WE?", GetWorld().components.interiorspawner.current_interior)
			self.sun.basetint = 1
			self.sun.r = 1
			self.sun.g = 1
			self.sun.b = 1
			self.moon.AnimState:PlayAnimation("moonsmall") --THIS DOESN'T SHOW THE MOON, JUST SETS THE ANIMATION FOR WHEN IT SHOWS UP
			self.background.pausecolorshift = false
			self.backfog.pausecolorshift = false
		end
	end)
	

	
	self.modelheight = 0
	
	--VANILLA DS CHANGE - POSSIBLE THE DUMBEST WORKAROUND FOR THE MOST ELUSIVE BUG IVE EVER FACED
	self.retnudge = 0
	
	-- self:UpdateSkybox(45)
	
	self.inst:StartUpdatingComponent(self) --DOES THIS WORK???
	self.inst:StartWallUpdatingComponent(self) --EH, DOESN'T SEEM TO HELP ALL THAT MUCH...
end)


--OKAY I REALLY NEED THIS THING IN HERE
local function normalize(angle)
    while angle > 360 do
        angle = angle - 360
    end
    while angle < 0 do
        angle = angle + 360
    end
    return angle
end



function RetManager:HideSkyboxes()
	print("SKYBOXES HIDDEN!!")
	self.background.AnimState:SetMultColour(0,0,0,0)
	self.background.pausecolorshift = true --TELLS THEM TO STOP DOING THAT THING WHERE THEY AUTO ADJUST TO THE AMBIENT LIGHT
	
	self.backfog.AnimState:SetMultColour(0,0,0,0)
	self.backfog.pausecolorshift = true
	
	if SKY_DECOR == true then --4-26-18
		self.cloud1.AnimState:SetMultColour(0,0,0,0)
		self.cloud2.AnimState:SetMultColour(0,0,0,0)
		self.cloud3.AnimState:SetMultColour(0,0,0,0)
		self.cloud1.pausecolorshift = true
		self.cloud2.pausecolorshift = true
		self.cloud3.pausecolorshift = true
		
		self.sun.AnimState:SetMultColour(0,0,0,0)
		self.moon.AnimState:SetMultColour(0,0,0,0)
		self.sun.pausecolorshift = true
		self.moon.pausecolorshift = true
	end
end


function RetManager:ShowSkyboxes()
	
	--DON'T EVER USE THIS INDOORS (YOU HEAR THE PROFESSOR'S VOICE ECHO IN YOUR HEAD...)
	if TheCamera.interior then --12-3-18 HAMLET CHANGE
		print("I AM INDOOOOOORS")
		return end 	--DONT WORRY, THIS WILL ALL GET RUN AGAIN ONCE THE PLAYER GOES BACK OUTSIDE

	--JUST TELL THEM TO RESUME THEIR LIGHT ADAPTION THING. THEY'LL FIGURE OUT THEIR COLORS FROM THERE
	self.background.pausecolorshift = false
	self.backfog.pausecolorshift = false
	
	if SKY_DECOR == true then --4-26-18
		self.cloud1.pausecolorshift = false
		self.cloud2.pausecolorshift = false
		self.cloud3.pausecolorshift = false
		
		self.sun.pausecolorshift = false
		self.moon.pausecolorshift = false
	end
end



--4-26-18 WHY THIS ISN'T IN SEASONMANAGER ILL. NEVER KNOW.   ILL ALSO NEVER KNOW WHY I DECIDED TO PUT IT HERE
function RetManager:GetMoistureShade()
	-- local moistureshade = (GetSeasonManager() and GetSeasonManager():GetWeatherLightPercent()) or 1
	-- tint = tint - math.clamp((1 - moistureshade), 0, 0.6) --4-26
	-- local percent = math.max(0, math.min(1,
	local weather = GetSeasonManager()	
	local moistureshade = ((weather.atmo_moisture - weather.moisture_floor) / (weather.moisture_limit - weather.moisture_floor))
	return moistureshade
end


--4-25-18 REUSEABLE -CLOUDS, MOON, AND SUN
function RetManager:UpdateSkyDecorations(dt) --LETS TRY ADDING DT FOR CLARITY
	if not dt then return end
	if (GetWorld() and GetWorld():IsCave()) or (SKY_DECOR == false) then return end --WE DONT WANT ANYTHIN TO SHOW IN CAVES
	
	local x, y, z = GetPlayer().Transform:GetWorldPosition()
	
	--OH HOLD UP...
	local vx,vy,vz = self.inst.Physics:GetVelocity() --NICE B)  DIDN'T THINK THIS WOULD WORK
	vx = (vx/30) * dt --DT COMES IN AS THE TIME PASSED BETWEEN THE LAST UPDATE. TRANSITIONING PERFECTLY BETWEEN VISUAL FRAMES
	vz = (vz/30) * dt 
	
	x = x + vx
	z = z + vz
	
	--4-25-18 AND NOW THIS GOOFY CLOUD
	self.moon.Transform:SetPosition( x-0, 13,  z-40)
	self.sun.Transform:SetPosition( x+0, 10,  z+40)
	self.cloud1.Transform:SetPosition( x+40, 6,  z-20)
	self.cloud2.Transform:SetPosition( x-32, 6,  z-32)
	self.cloud3.Transform:SetPosition( x+32, 6,  z+32)
end



--1-4-18 FPS CHANGE - GET THE ITEM AT YOUR FEET
function RetManager:GetEntitiesAtFeet()
	local x, y, z = GetPlayer().Transform:GetWorldPosition()
		
	local angle = TheCamera:GetHeadingTarget() * DEGREES
		
		
	--WE'LL CHECK THE OBJECTS CLOSEST TO US FIRST
	local tx = math.cos(angle) * (self.reach /2)
	local ty = math.sin(angle) * (self.reach /2)
	
		
		
	--WE ALSO NEED ONE TO GET ENTITIES RIGHT IN FRONT OF US (FOR WORKING) --SCRAPPING THIS VERSION. WE'LL JUST USE
	local ents = {}
	-- local closeents = {}
	-- local function entitiesatrange(range)
		-- for k,v in pairs(TheSim:FindEntities( x+tx,  y,  z+ty,  (range), {}, {"player", "FX"})) do
			-- return v ~= nil and v.entity and v.Transform and v
		-- end
	-- end
	
	
	--CHECK TO SEE IF PLAYER IS ALLOWED TO BE SELECTED / IS LOOKING AT SELF
	local function ShouldGrabPlayer( inst )
		if inst ~= GetPlayer() then return true end --WHO CARES, THEY AINT US.
		
		if self.selfselecable == false then 
			return false
		elseif inst == GetPlayer() and TheCamera.pitch > 60 then
			return true
		end
	end
	

	for k,v in pairs(TheSim:FindEntities( x+tx,  y,  z+ty,  self.size/2, {}, {"INLIMBO", "FX", "NOCLICK"})) do --12-8-18 HEY WE KINDA FORGOT AN IMPORTANT ONE. "NOCLICK"
		-- print("WHACHA GOT FOR ME?", v)
		-- return v ~= nil and v.entity and v.Transform and v and v ~= GetPlayer().floorret
		-- return v ~= nil and v.entity and v.Transform and v ~= GetPlayer().floorret and v
		-- return v ~= nil and v.entity and v.Transform and v
		 -- table.insert(ents, v)
		
		--NEW RULE! ONLY THESE KINDS OF ENTS CAN ENTER
		if v ~= nil and v.entity and v.Transform and v and v ~= GetPlayer() then 
			table.insert(ents, v)
			-- print("CLOSE RANGE", v)
		end
	end
	
	
	
	--AND NOW FOR OBJECTS BEHIND THAT
	-- local tx = (math.cos(angle)/360) * reach --??? MATH IS HARD,,,
	local tx = math.cos(angle) * self.reach 
	local ty = math.sin(angle) * self.reach
	
	-- for k,v in pairs(TheSim:FindEntities( x+tx,  y,  z+ty,  self.size , {}, {"player", "FX"})) do
	for k,v in pairs(TheSim:FindEntities( x+tx,  y,  z+ty,  self.size , {}, {"INLIMBO", "FX", "NOCLICK"})) do
		if v ~= nil and v.entity and v.Transform and ShouldGrabPlayer(v) and v then 
			table.insert(ents, v)
			-- print("CLOSE RANGE", v)
		end
		 -- print("CLOSE RANGE")
	end
	--PLAYERS MAY SELECT THEMSELVES ONLY IF SELFSELECTABLE IS TRUE
	--IF NOTHING ELSE IS IN FRONT OF US, CHECK IF WE SHOULD SELECT OURSELF
	
	--IF WE ARE HOLDING AN ITEM FROM AN OVERFLOWED INVENTORY AND LOOKING DOWN AT OURSELF, PRIORITIZE OUR SELF
	if self.inst.components.inventory:IsFull() and self.inst.components.inventory:GetActiveItem() ~= nil and TheCamera.pitch > 60 then
		ents[1] = self.inst
	end
	
	--1-22-18 IF A SPECIAL FOCUS ENT IS BEING INSERTED FROM OUTSIDE, JUST RETURN THAT AS OUR ENT.
	-- if self.spotlightent ~= nil then
	if self:CheckSpotlightEnt() then
		ents[1] = self.spotlightent
	end
	
	
	--1-27 NOW LETS CHECK PRIORITY. CHECK FOR NON-EXAMINING ACTIONS FIRST. WE WANT THE LOGS ON THE GROUND, NOT EXAMINE THE STUMP DUMMY
	local entpriority = {}
	for k,v in pairs(ents) do
		local act = self.inst.components.playeractionpicker:GetClickActions(v, Vector3(x+tx, y, z+ty)) --VANILLA DS CHANGE - I GUESS THEY JUST CALL IT "GetClickActions"
		
		--4-26-18 LETS TRY AND FIX THIS WOODIE BUG
		if act == nil then 
			break end
		
		for i, b in ipairs(act) do --retmanager.lua:412: bad argument #1 to 'ipairs' --4-26-18 WHAT KIND OF ERROR IS THIS?...
			if b.action == ACTIONS.ATTACK then
				table.insert(entpriority, v)
				if TheInput:IsControlPressed(CONTROL_FORCE_ATTACK) then --3-20-18
					return {v} --FOUND ATTACKABLE ENTITY WHILE HOLDING FORCEATTACK! RETURN THIS AND NOTHING ELSE, WE'RE DONE HERE
				end
				
			elseif i == 1 and b.action == ACTIONS.LOOKAT then
				break --IF ITS MAIN ACTION IS TO BE LOOKED AT, DONT PUT IT ON THE PRIORITY LIST

			else --AS LONG AS IT ISNT LOOKAT, WE DONT CARE
				table.insert(entpriority, v) 
			end
		end
		-- print("ENTS", v)
	end
	
	--NOW ADD THE REST OF THE ENTS ONTO THE END OF THIS TABLE. IF NO OBJECTS OF PRIORITY WERE FOUND, WE'LL TAKE WHATEVER WAS LEFTOVER
	for k,v in pairs(ents) do
		 table.insert(entpriority, v)
	end
	
	return entpriority --THE NEW KING --THE USEFUL ACTION ITEMS GET RETURNED BEFORE THE ONES TO EXAMINE
	
	
	-- local lmbs = self:GetLeftClickActions(position)
	-- for i, v in ipairs(lmbs) do
		-- if v.action == ACTIONS.DROP then
			-- return v
		-- end
	-- end
	
	
	-- print("THESE ENTS", ents[0], "and", ents[1])
	
	-- for k,v in pairs(ents) do
		 -- print("ENTS", v)
	-- end
	
	-- return entitiesatrange(self.size) and entitiesatrange(self.size - 1) or {}
	-- return ents
	
	
	
	-- return {}
end



--IF IN CONTACT WITH A PHYSICAL OBJECT, MAKE SURE WE ARE BOTH LOOKING AT IT AND WITHIN RANGE
function RetManager:CheckSpotlightEnt()
	
	if self.spotlightent ~= nil and self.spotlightent:IsValid() then
		
		--IF WE AREN'T LOOKING AT IT, RETURN FALSE, BUT DON'T REMOVE IT FROM THE SPOTLIGHT SLOT, IN CASE WE LOOK AT IT AGAIN WITHOUT MOVING
		local ent_x, ent_y, ent_z = self.spotlightent.Transform:GetWorldPosition()
		local angle = self.inst:GetAngleToPoint(ent_x, ent_y, ent_z)
		-- local mydist = math.sqrt(self.inst:GetDistanceSqToPoint(ent_x, ent_y, ent_z))
		--VANILLA DS CHANGE --OKAY... I GUESS LETS TRY SOMETHING DIFFERENT
		local p0 = Vector3(self.spotlightent.Transform:GetWorldPosition())
		local p1 = Vector3(self.inst.Transform:GetWorldPosition())
		local mydist = math.sqrt(distsq(p0, p1))
		angle = normalize(180 - angle) --CLOSE ENOUGH! :D
		local myangle = TheCamera:GetHeadingTarget()
		
		--IF WE LEAVE RANGE, REMOVE IT FROM OUR SPOTLIGHT SLOT AND RETUN FALSE
		if mydist > (self.spotlightdist + 0.2) then
			self.spotlightent = nil
			self.spotlightdist = nil
			return false
		end --OTHERWISE, DONT DO ANYTHING YET, LETS SEE IF WE'RE LOOKING AT IT
		
		if math.abs(angle - myangle) <= 45 then --IF THE PLAYER IS LOOKING IN THE GENERAL DIRECTION OF IT'S CENTER MASS
			return true
		else
			return false
		end
		
	end
end



--11-14-18 HAMLET CHANGE --RECREATE THE RETICLE IN CASE THE ACT OF EXITING A BUILDING HAS DESTROYED IT
function RetManager:RespawnFloorRet()
	self.inst.floorret = SpawnPrefab("reticule")
	self.inst.floorret.AnimState:SetMultColour(1,1,1,0.5)
	self.inst.floorret.AnimState:SetLightOverride(1)
end


function RetManager:UpdateFloorRet(dt) --LETS TRY ADDING DT FOR CLARITY
	-- if not (GetPlayer() and GetPlayer().floorret and TheCamera) then return end
	-- local dt = dt or 1
	
	--HAMLET CHANGE: SOMETIMES FLOORRET ISNT BACK YET!! MAKE SURE IT ISNT STALE
	if not (dt and GetPlayer().floorret:IsValid()) then 
		self:RespawnFloorRet()
		return end 
	
	local x, y, z = GetPlayer().Transform:GetWorldPosition()
		local angle = TheCamera:GetHeadingTarget() * DEGREES
		
		local reach = self.reach - self.retnudge
		
		-- local tx = (math.cos(angle)/360) * reach --??? MATH IS HARD,,,
		local tx = math.cos(angle) * (reach - 0.2) --LETS MAKE THEM JUUUUST A BIT SHORTER, 
		local ty = math.sin(angle) * (reach - 0.2)
	-- print("IM HERE")
	
	--OH HOLD UP...
	local vx,vy,vz = self.inst.Physics:GetVelocity() --NICE B)  DIDN'T THINK THIS WOULD WORK
	vx = (vx/30) * dt --DT COMES IN AS THE TIME PASSED BETWEEN THE LAST UPDATE. TRANSITIONING PERFECTLY BETWEEN VISUAL FRAMES
	vz = (vz/30) * dt --"dont tarve" lol
	
	-- print("CRASH DUMMY", x, tx, vx, y, z, ty, vz, GetPlayer().floorret)
	GetPlayer().floorret.Transform:SetPosition( x+tx+vx,  y,  z+ty+vz)
	
	
	--MAYBE I JUST NEED TO ADD A MOTOR
	-- print("VELOCITY A", GetPlayer().floorret.Physics:GetVelocity())
	-- print("VELOCITY P", GetPlayer().Physics:GetVelocity())
	-- local vx,vy,vz = self.inst.Physics:GetVelocity() --IT JUST STRAIGHT UP REFUSES TO BUDGE, PHYSICS DONT WORK ON IT
	-- GetPlayer().floorret.Physics:SetVel(vx,vy,vz)
	-- print("VELOCITY B", GetPlayer().floorret.Physics:GetVelocity())
	
	--CAN WE RETURN A VALUE WITHOUT CRASHING??
	--OR BETTER YET
	-- if self.inst.components.placer then 
		-- self.inst.components.placer.selected_pos = ( GetPlayer().floorret:GetPosition() )
		-- print ("MY PLACEMENT?", GetPlayer().floorret:GetPosition())
	-- end
	
	
	-- SetPosition(x + self.screen_offset.x, y + self.screen_offset.y, 0)
	-- if self.inst.components.talker.widget then
		-- self.inst.components.talker.widget:SetPosition(10, 2, 0)
		-- print("WIDGET DETECTED")
	-- end
end


function RetManager:UpdateSkybox()
	
	local x, y, z = GetPlayer().Transform:GetWorldPosition()
	-- local angle = TheCamera:GetHeadingTarget() * DEGREES
	local angle = TheCamera.heading * DEGREES
	local dist = -50 -- -10
		
	--LETS TRY THIS...
	-- angle = angle - (90 * DEGREES)
	
	local skybox_raise = 0.2 --VANILLA DST CHANGE-  SPECIFICALLY FOR WHIPWRECKED. LOOKS BETTER ON THE SEAS
	-- if IsDLCEnabled(CAPY_DLC) then --IS IT REALLY CALLED CAPPY DLC?? LOL
	if SaveGameIndex:IsModeShipwrecked() then
		skybox_raise = 1.0
	end
	
	local tx = math.cos(angle) * dist
	local ty = math.sin(angle) * dist
	self.background.Transform:SetPosition( x+tx, skybox_raise,  z+ty) --0.5 IS TOO HIGH, WE CAN SEE STUFF PEEKING OUT UNDER IT
	
	
	
	-- --NOW WE HAVE TO TEST IF THE SKYBOX IS INBETWEEN THE PLAYER AND THE WORLD
	-- -- local worldangle = math.abs(TheCamera:GetHeadingTarget() -  (GetPlayer():GetAngleToPoint(0,0,0) + 180))
	-- -- local worldangle = math.abs(math.abs(TheCamera:GetHeadingTarget() -  (GetPlayer():GetAngleToPoint(0,0,0) + 180)) - 180)
	-- local worldangle = math.abs(math.abs(TheCamera:GetHeadingTarget() -  (GetPlayer().Transform:GetRotation() + 180)) - 180)
	-- if worldangle >= 90 and worldangle <= 270 then
	-- -- if worldangle <= 180 then
		-- -- angle = angle + (45 * DEGREES)
		-- -- dist = -2
		-- -- angle = angle + (180 * DEGREES)
		-- print("ALTERNATE ANGLE", angle)
	-- end
	
	--ALRIGHT. FINE. JUST FORGET IT. THATS ONE WHOLE ENTIRE DAY WASTED ON THIS
	
	-- if worldangle <= 0 and worldangle <= 180 then
		-- angle = angle + (45 * DEGREES)
	-- end
		
	
	local skybox_raise = 0.25 --VANILLA DST CHANGE- 
	if SaveGameIndex:IsModeShipwrecked() then
		skybox_raise = 0.35
	end
	
	local dist = -49 -- -35 --40
	local tx = math.cos(angle) * dist
	local ty = math.sin(angle) * dist
	self.backfog.Transform:SetPosition( x+tx, skybox_raise,  z+ty)
	
	local tint = 0.3
	-- self.backfog.AnimState:SetMultColour(0.82*tint, 0.92*tint, 1*tint, 0.1*tint) --NOW HANDLED IN PREFAB FILE
	
	
	--[[
	--I DONT THINK THIS ONE IS EVEN VISIBLE
	local tint = 0.6
	local dist = -40
	local tx = math.cos(angle) * dist
	local ty = math.sin(angle) * dist
	self.backmist.Transform:SetPosition( x+tx, 0.5,  z+ty)
	-- self.backmist.AnimState:SetMultColour(0.82*tint, 0.92*tint, 1*tint, 0.1*tint) 
	]]
	
	-- print("WORRLD ANGLE. ", worldangle)
	-- print("WORRLD ANGLE. ", TheCamera:GetHeadingTarget(), (GetPlayer():GetAngleToPoint(0,0,0) + 180))
	
	-- self.background.Transform:SetPosition( x+tx, 0,  z+ty)
	 -- self.background.Transform:SetScale(0.1,20,1)
	
	
	-- self.backgroundn.Transform:SetPosition( x+10, 0,  z+0)
	-- self.backgrounds.Transform:SetPosition( x-10, 0,  z+0)
	-- self.backgrounde.Transform:SetPosition( x+1, 0,  z+10)
	-- self.backgroundw.Transform:SetPosition( x+0, 0,  z-10)
	
	-- self.backgroundn.Transform:SetScale(10,20,1)
	
	
end


local floorbeam_green_tinge = 0.5 --THE FLOORBEAM CAN BE EITHER RED OR ORANGE. ONLY THE G OF RGB NEEDS TO BE ADJUSTED TO MAKE THESE COLOURS

function RetManager:CheckRange()
	-- if self.inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS) then
	-- local item = self.inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS) --OH... THATS RIGHT. WE CANT USE THIS CLIENT SIDE
	local item = self.inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS)
	local active_item = self.inst.components.inventory:GetActiveItem() --LETS SEE IF THEYRE HOLDING SOMETHING. AS IN, HAVE IT SELECTED
	local maxrange = item and item.components.weapon and item.components.weapon.attackrange or -self.basereach
	
	--11-9-18 HAMLET CHANGE: -ABORT IF THE RETINAL IS NOT THERE AFTER LEAVING THE RUINS
	if not GetPlayer().floorret:IsValid() then  
		return end
	
	--VANILLA DS CHANGE - WE SHOULDN'T NEED THIS VERSION ANYMORE, NOW THAT EVERYONE IS A HOST
	-- if item and  --THERE A BIG LIST OF REASONS. CONTINUED BELOW
	-- (item:HasTag("projectile") or item:HasTag("rangedweapon") or (item:HasTag("nopunch") and not item:HasTag("umbrella"))) then --NOPUNCH INCLUDES UMBRELLAS... Y THO
		-- maxrange = 9 --THIS SEEMS THE AVERAGE FOR MOST RANGED WEAPONS
	-- end
	
	--VANILLA DS CHANGE --QUITE POSSIBLE THE DUMBEST WORKAROUND TO THE MOST BIZZARE ELLUSIVE BUG IVE EVER ENCOUNTERED
	if active_item and active_item.components.deployable then
		maxrange = 0
		self.retnudge = 1
	else
		self.retnudge = 0 --WHY AM I EVEN PUTING THIS IN THE RANGE CALCULATOR FN??? OH WELL
	end
	
	--CHECK TO SEE IF ITEM ALLOWS FULL SCREEN CASTING
	-- if item and (item.components.spellcaster or item.components.blinkstaff) then  -THESE DONT WORK CLIENTSIDE, DUMMY
	if item and (item.components.reticule) then
		maxrange = 17 --SEEMS FAIRLY CLOSE TO FULL SCREEN SIZE
	end
	
	--SHIPWRECKED DS CHANGE - BOAT-CANONS NEED TO BE CHECKED AND ACCOUNTED FOR
	if self.inst.components.driver and self.inst.components.driver:GetIsDriving() == true then
		if maxrange == -self.basereach then --5-13 --OTHERWISE IT CANCELS OUT ANY HELD RANGED OBJECTS
			maxrange = -self.basereach * 2
		end
		local cannonslot = self.inst.components.driver.vehicle.components.container
		if cannonslot and cannonslot:GetItemInBoatSlot(BOATEQUIPSLOTS.BOAT_LAMP) and cannonslot:GetItemInBoatSlot(BOATEQUIPSLOTS.BOAT_LAMP):HasTag("cannon") then
			maxrange = 17 --BASICALLY GIVE THEM FULL SCREEN REIGHN
		end
	end
	
	
	if maxrange > -self.basereach * 2 then
		maxrange = math.clamp( maxrange - (((TheCamera.pitch - 2) /2) - 2 ),   -self.basereach,   maxrange + 2)
		self.size = self.basesize + (maxrange / 10) --INCREASE FLOORRET SIZE AS USER AIMS FURTHER AWAY
		GetPlayer().floorret.AnimState:SetMultColour(1,0,0,1)
		floorbeam_green_tinge = 0 --MAKES IT PURELY RED
	else
		GetPlayer().floorret.AnimState:SetMultColour(0.2,0.2,0.2,0.2)
		self.size = self.basesize
		if self.inst:HasTag("aquatic") then --SHIPWRECKED DS CHANGE
			self.size = self.basesize * 1.5
			GetPlayer().floorret.AnimState:SetMultColour(0.3,0.3,0.3,0.3)
		end
	end
	-- end
	
	
	--IF ITS LOCATIONAL, CHANGE THE RETICULE
	-- if item and (item.components.spellcaster or item.components.blinkstaff) then  --THESE DONT WORK CLIENTSIDE, DUMMY
	if item and (item.components.reticule) then
		self.size = self.basesize + (maxrange / 20)
		GetPlayer().floorret.AnimState:SetMultColour(1,0.5,0,1)
		floorbeam_green_tinge = 0.5
	end
	
	
	--IF WE HAVE AN ACTIVE ITEM, MAKE IT GREEN
	if self.inst.components.inventory:GetActiveItem() ~= nil then
		floorbeam_green_tinge = 1 --SURE. WHY NOT.
		GetPlayer().floorret.AnimState:SetMultColour(1,1,0,1)
	end
	
	
	--IF THE RETICULE IS GETTING FAR AWAY, CALL IN THE FLOOR BEAM TO HELP THE PLAYER DIFFERENTIATE DISTANCE
	if maxrange > 8 then
		self.floorbeam:Show()
		local x, y, z = GetPlayer().floorret.Transform:GetWorldPosition()
		local tint = (maxrange - 8) / 10
		if tint >= 0.5 then tint = 0.5 end --NO GREATER THAN 0.5
		-- self.floorbeam.AnimState:SetMultColour(tint,tint,tint,tint)
		self.floorbeam.AnimState:SetMultColour(tint,  floorbeam_green_tinge * tint  ,0 ,tint) --NEW VERSION ALSO CONTROLS THE COLOUR BETTER
		self.floorbeam.Transform:SetScale(self.size*2 ,2, self.size*2 )
		self.floorbeam.Transform:SetPosition(x,y,z) --LETS JUST ALWAYS KEEP THEM ON TOP OF EACH OTHER. DONT WANT THEM TOO FAR APART
		
	else
		-- self.floorbeam.AnimState:SetMultColour(0,0,0,0)
		self.floorbeam:Hide()
	end
	
	
	
	--NAH. WE DONT REALLY NEED THIS NOW THAT FOV IS BIGGER
	-- if TheCamera.pitch > 50 then
		-- maxrange = 1 --ALLOWS PLAYERS TO TARGET THEMSELVES
	-- end
	
	if TheCamera.pitch > 60 then
		maxrange = 0 --MORE PRECISE CLOSER RANGE TARGETING WHEN LOOKING DOWN
	end
	
	
	if self.mouselock == false then
		GetPlayer().floorret.AnimState:SetMultColour(0,0,0,0)
	end
	
	-- print("AND HERES THE PITCH", TheCamera.pitch)
	
	self.reach = -maxrange
	GetPlayer().floorret.Transform:SetScale(self.size,self.size,self.size) --RESIZE FLOORRET
end


--VANILLA DST CHANGE -- HERES JUST A COPY OF INV_REPLICA'S GETOPENCONTAINER'S FUNCTION
function RetManager:GetOpenContainers()
    if not (self.inst.components.inventory) then return end
	
	if self.inst.components.inventory ~= nil then
        return self.inst.components.inventory.opencontainers
    elseif self.inst.HUD ~= nil then
        local containers = {}
        for k, v in pairs(self.inst.HUD.controls.containers) do
            if v ~= nil and v.inst.entity:IsVisible() and k:IsValid() then
                containers[k] = true
            end
        end
        return containers
    end
end

--CHECK FOR OPEN CONTAINERS TO SEE IF MOUSE SHOULD UNLOCK
function RetManager:CheckOpenContainers()
	
	-- local opencontainers = self.inst.components.inventory:GetOpenContainers() or {}
	local opencontainers = self:GetOpenContainers() or {} --VANILLA DST CHANGE -- A COPY OF INV_REPLICA'S GETOPENCONTAINER'S FUNCTION
	--self.inst.components.inventory.opencontainers
	local numopen = 0
	
	for k,v in pairs(opencontainers) do
			-- k.components.container.type
		-- local inventory = GetPlayer().components.inventory or nil
		-- local backpack = inventory:GetOverflowContainer() --OH, THIS IS THE TABLE OF EVERY SLOT IN A BACKPACK
		 -- print("HERES WERE I KEEP ALL MY WEAPONS ", v, k)
		 -- print("LIKE MY BAG?", k.components.container.type)
		 
		 --IGNORE CONTAINERS LIKE BACKPACKS 
		local brand = k.components.container and k.components.container.type or nil
		if brand and (brand == "chest" or brand == "cooker" or (brand == "boat" and not self.inst.components.driver.driving)) then --VANILLA DS CHANGE -- ADDING BOAT
			numopen = numopen + 1
		else
			--self.containeropened = false
			--DO NOTHING!
		end
	end
	
	
	if numopen > 0 then --IF ONE OR MORE CHEST-LIKE CONTAINERS ARE OPEN, ENABLE
		self.containeropened = true
	else
		self.containeropened = false
	end
	-- print(self.containeropened)
	
end



function RetManager:ResetModel()
	self.modelheight = 0
	GetPlayer().Transform:SetScale(1,1,1)
	-- TheCamera:SetOffset(0, 1, 0)
	TheCamera.targetoffset.y = 1
end

function RetManager:SetModelHeight(height)
	self.modelheight = height
	-- TheCamera:SetOffset(0, 1+height, 0)
	TheCamera.targetoffset.y = 1 - height
end


function RetManager:UpdatePlayermodel()
	
	-- local worldangle = math.abs(math.abs(TheCamera:GetHeadingTarget() -  (GetPlayer().Transform:GetRotation() + 180)) - 180)
	-- -- if worldangle >= 90 and worldangle <= 270 then
	-- if worldangle >= 60 and worldangle <= 120 then
		-- GetPlayer().AnimState:SetMultColour(0, 0, 0, 0) 
		-- -- print("ALTERNATE ANGLE", angle)
	-- else
		-- GetPlayer().AnimState:SetMultColour(1, 1, 1, 1) 
	-- end
	
	
	--NO!! DONT MESS WITH THIS PART. IT MAKES DETECTION AWEFUL
	-- if GetPlayer():IsVisible() then
		-- local x, y, z = GetPlayer().Transform:GetWorldPosition()
		-- GetPlayer().Transform:SetPosition( x, self.modelheight,  z)
	-- end
	
	-- print("ALTERNATE ANGLE", worldangle)
	
	
	--NOW WE HAVE A USE FOR THIS! FOR CLIENTS ONLY, CONSTANTLY RUN INNEWSTATE()
	-- if not TheWorld.ismastersim then
		-- if self.inst.sg and self.inst.sg:InNewState() then
			-- self.inst:PushEvent("newstate", {statename = self.inst.sg.currentstate.name})
			-- print("NEWSTATE ACTIVATED", self.inst.sg.currentstate.name)
		-- end
		-- print("NEWSTATE?", self.inst.sg)
	-- end
end


function RetManager:GetControlerStickInput()
	if not TheInput:ControllerAttached() or (self.inst.FPSmode == false) then return end --WADDA YOU DOING HERE
	
	local hor_stick = TheInput:GetAnalogControlValue(CONTROL_INVENTORY_RIGHT) - TheInput:GetAnalogControlValue(CONTROL_INVENTORY_LEFT)
	local vert_stick = TheInput:GetAnalogControlValue(CONTROL_INVENTORY_DOWN) - TheInput:GetAnalogControlValue(CONTROL_INVENTORY_UP)
	
	--YIKES. GIVE EM SOME DEAD ZONES.
	if math.abs(hor_stick) < 0.2 then hor_stick = 0 end
	if math.abs(vert_stick) < 0.2 then vert_stick = 0 end
	
	hor_stick = hor_stick * 4 * (1+TUNING.FPS_SENSITIVITY)
	vert_stick = vert_stick * 4 * (1+TUNING.FPS_SENSITIVITY)
	
	TheCamera:SetHeadingTarget(TheCamera:GetHeadingTarget() - hor_stick) 
	TheCamera.pitch = math.clamp(TheCamera.pitch + vert_stick,  -75, 75)
end


function RetManager:OnUpdate(dt) --2-21-17 IS THIS HOW THIS WORKS? I DUNNO, IVE NEVER DONE THIS BEFORE
	-- -- print("IS THIS HOW IT WORKS?")
	if self.inst.FPSmode == false then return end
	self:CheckRange()
	self:UpdateSkybox()
	self:UpdatePlayermodel()
	self:CheckOpenContainers()
	
	self:GetControlerStickInput()
	
	
end

function RetManager:OnWallUpdate(dt)
	self:UpdateFloorRet(dt) --HAHA!!
	self:UpdateSkyDecorations(dt) --4-25-18 REUSEABLE
end


--WELL, THIS WAS REPLACED WITH LockOnPlayerAngle() BUT I GUESS I'LL JUST LEAVE IT HERE IN CASE I CHANGE MY MIND
--FOR THE CAMERA TO AUTO TURN TO FACE THE PLAYER'S COMBAT TARGET	
function RetManager:LockOnTarget(target)
	-- local target = inst.components.combat:GetTarget()
	if self.combattarget == nil then return end
	
	--WELL, SINCE IT DOESN'T ALWAYS RETURN THE CORRECT TARGET, LETS GRAB GETTARGET IF IT EXISTS
	local target = self.inst.components.combat:GetTarget() or self.combattarget --target
		
	if target ~= nil then
		local facepos_x, facepos_y, facepos_z = target.Transform:GetWorldPosition()
		local angle = self.inst:GetAngleToPoint(facepos_x, facepos_y, facepos_z)
		angle = normalize(180 - angle) --CLOSE ENOUGH! :D
		
		TheCamera:TempSlowTurn() --FACE US IN THE RIGHT DIRECTION, BUT DONT SNAP OUR NECKS
		-- print("TARGET AQUIRED", angle, GLOBAL.TheCamera:GetHeadingTarget())
		
		TheCamera:SetHeadingTarget(angle)
	end
end



function RetManager:SetLockTarget(target)
	self.combattarget = target
end

function RetManager:GetLockTarget()
	return self.combattarget
end


--OR... COULDN'T I JUST DO THIS?...
function RetManager:LockOnPlayerAngle() --THIS WAS SO MUCH SIMPLER, I CAN'T BELEIVE I DID ALL THAT EXTRA WORK FOR NOTHING
	
	local angle = normalize(GetPlayer().Transform:GetRotation())
	angle = normalize(180 - angle) --CLOSE ENOUGH! :D
		
	TheCamera:TempSlowTurn() --FACE US IN THE RIGHT DIRECTION, BUT DONT SNAP OUR NECKS
		
	TheCamera:SetHeadingTarget(angle)
end


--TURNS THE PLAYER TO FACE OUR CAMERA ANGLE
function RetManager:FacePlayerToCamera()

	local angle = TheCamera:GetHeadingTarget()
	angle = normalize(180 - angle) 
		
	self.inst.Transform:SetRotation(angle)
end



--IS PLAYER LOOKING AT SPECIFIC TARGET
function RetManager:IsPlayerLookingAt(inst, target, anglethresh)
	
	if target ~= nil and target:IsValid() then
		
		--IF WE AREN'T LOOKING AT IT, RETURN FALSE, BUT DON'T REMOVE IT FROM THE SPOTLIGHT SLOT, IN CASE WE LOOK AT IT AGAIN WITHOUT MOVING
		local ent_x, ent_y, ent_z = target.Transform:GetWorldPosition()
		local angle = inst:GetAngleToPoint(ent_x, ent_y, ent_z)
		angle = normalize(180 - angle) --CLOSE ENOUGH! :D
		local camangle = TheCamera:GetHeadingTarget() --THIS DOESNT SEEM RIGHT...
		-- local camangle = normalize(90 - TheCamera:GetHeadingTarget()) --270???
		
		
		--IF WE LEAVE RANGE, REMOVE IT FROM OUR SPOTLIGHT SLOT AND RETUN FALSE
		-- local mydist = math.sqrt(inst:GetDistanceSqToPoint(ent_x, ent_y, ent_z))
		-- print("DIST BETWEEN US", mydist)
		-- if mydist > (self.spotlightdist + 0.2) then
			-- self.spotlightent = nil
			-- self.spotlightdist = nil
			-- return false
		-- end --OTHERWISE, DONT DO ANYTHING YET, LETS SEE IF WE'RE LOOKING AT IT
		
		
		--SOMETHINGS... WRONG WITH THIS. IT GOES TO 200 AND THEN REVERTS BACK TO 150 IN REVERSE...
		-- print("ANGLE BETWEEN US", math.abs(angle - camangle), angle, camangle)
		
		-- local anglediff = math.abs(angle - camangle)
		local anglediff = math.abs( 180 - normalize(angle - camangle)) --CLOSEST ONE SO FAR
		-- local anglediff = math.abs(normalize( 180 - (angle - camangle)))
		
		-- print("ANGLE BETWEEN US",anglediff, angle, camangle)
		
		-- if anglediff <= anglethresh then --IF THE PLAYER IS LOOKING IN THE GENERAL DIRECTION OF IT'S CENTER MASS
		if anglediff >= (180 - anglethresh) then --LOL MATH IS DUMB
			return true
		else
			return false
		end
		
	end
end




--REAL NICE :/  SAME THING BUT WE DONT HAVE A TARGET. ONLY AN ANGLE
function RetManager:IsPlayerLookingInDirection(inst, targetangle, anglethresh)
	
	local angle = normalize(180 - targetangle) --CLOSE ENOUGH! :D
	local camangle = TheCamera:GetHeadingTarget()
	
	if math.abs(angle - camangle) <= anglethresh then --IF THE PLAYER IS LOOKING IN THE GENERAL DIRECTION OF IT'S CENTER MASS
		return true
	else
		return false
	end
end


-- function RetManager:OnSave()
    -- return {
        -- usedroar = self.usedroar,
    -- }
-- end

-- function RetManager:OnLoad(data)
    -- if data ~= nil then
        -- self.usedroar = data.usedroar or self.usedroar
		-- print("IS IT WORKING MOM?", self.usedroar)
    -- end
-- end




return RetManager
