local assets=
{
	Asset("ANIM", "anim/background_image.zip"),
}

local function fn()  --DSTCHANGES Sim
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
    --MakeInventoryPhysics(inst)
    inst.entity:AddSoundEmitter()
	
	-- inst.entity:AddNetwork() --DSTCHANGES --or...maybe dont?
    
    inst.AnimState:SetBank("background_image")
    inst.AnimState:SetBuild("background_image")
    inst.AnimState:PlayAnimation("idle")
	inst.AnimState:SetLayer( LAYER_BACKGROUND )
	
	inst.AnimState:SetLightOverride(1) --GOOD GOD IM A GENIUS. NICE THINKING, ME
	
	inst:AddTag("skybox")
	inst:AddTag("NOBLOCK") --VANILLA DS CHANGE - FOR BUILDABLES SEEING CURSOR AS BEING IN THE WAY
	
	local sizev = 20
	inst.Transform:SetScale(sizev,sizev,sizev)
	
	-- inst.Transform:SetPosition( 2, 0, 0)
	
	--inst.AnimState:SetLayer( LAYER_BACKGROUND )
	--inst.AnimState:SetLayer( LAYER_FRONTEND )
	
	--11-16-17 JUST ADDING VISIBILITY FOR TESTING PURPOSES
	-- inst.AnimState:SetBank("nitre")
	-- inst.AnimState:SetBuild("nitre")
	
	
	--12-16-17 SLOWLY FADE THE COLOR AS NIGHT FALLS
	-- inst.entity:AddLightWatcher()
	-- -- !!!! THESE ARE VERY RESOURCE INTENSIVE!!! ---
	-- inst:DoPeriodicTask(0, function() 	
		-- -- inst.AnimState:GetMultColour(0.5,0.5,0.5,0.5)
		-- local light = inst.LightWatcher:GetLightValue() - 0.05
		-- -- inst.AnimState:SetMultColour(light,light,light, light)
		-- inst.AnimState:SetMultColour(light, light, light, light)
		-- -- inst.LightWatcher:GetLightValue()
	-- end)
	
	
	
	--1-14 CAN I JUST... SET SOME VARIABLES IN HERE??
	inst.r = 0.42 --82
	inst.g = 0.92
	inst.b = 1
	inst.t = 0.1
	inst.basetint = 1
	inst.inverselight = false --4-25-18 FOR OBJECTS LIKE THE MOON TO ONLY SHOW AT NIGHT
	
	--2-18-18 WELL IT'D KINDA SUCK TO HAVE THESE APPEAR ON SCREEN IN DEFUALT CAMERA VIEW
	inst.pausecolorshift = false
	
	--DS CHANGE VANILLA
	local TheWorld = GetWorld()
	
	--VANILLA DS CHANGE - I GUESS THIS IS HOW AMBIENTLIGHT WORKS IN THIS GAME
	inst:DoTaskInTime(0.2, function()  --IT NEEDS A QUICK DELAY BECAUSE CLOCK DOESN'T PROPERLY STORE DAY PHASE ON THE FIRST FRAME
		local ambientlight = GetSeasonManager() and GetSeasonManager():GetWeatherLightPercent() or 1
		if (GetClock():IsNight() and not (GetClock():GetMoonPhase() and (GetClock():GetMoonPhase() == "full"))) or GetWorld():IsCave() then --IF WE LOAD IN DURING NIGHT, FORGET IT.
			ambientlight = 0
		end
		
		--REAL QUICK JUST CHECK IF ITS NIGHT OUT AS WE SPAWN IN, AND MAKE IT BLACK IF IT IS
		-- if TheWorld.components.ambientlighting:GetVisualAmbientValue() == 0 then
		if ambientlight == 0 then
			inst.AnimState:SetMultColour(0,0,0,1) 
		end
	end)
	
	
	
	
	-- 12-16-17 SLOWLY FADE THE SKYBOX COLOR AS NIGHT FALLS -DST CHANGE
	local function UpdateSkyColor(sky, tint)  --VANILLA DS CHANGE REUSEABLE - MAKE THE SKY RED AT DUSK
		-- sky.AnimState:SetMultColour(0.12*tint, 0.12*tint, 1*tint, 1) 
		-- sky.AnimState:SetMultColour(inst.r * tint,  inst.g*tint,  inst.b*tint, inst.t*tint)		
		
		--4-26 -LETS TRY TO KEEP THE SKY DARKENED WHEN IT STARTS TO RAIN
		local moistureshade = GetPlayer().components.retmanager:GetMoistureShade() --4-26
		-- print("THE MOISTNESS", moistureshade)
		tint = tint - math.clamp((-0.75 + moistureshade) * 3, 0, 0.6) --4-26
		
		--OHH! THIS IS CLEVER~  --TOO BAD IT DOESN'T WORK :c
		-- inst.AnimState:SetLightOverride(TheWorld.components.ambientlighting:GetVisualAmbientValue())
		--IF WE SET IT TO 1 AT ALL TIMES, LIGHT CANT MAKE IT ANY BRIGHTER!!! NO MORE NORTHERN LIGHTS!!!
		-- inst.AnimState:SetLightOverride(1) --GOOD GOD IM A GENIUS. NICE THINKING, ME
		--1-22-18 LETS TRY AND MATCH THE SKY COLORS TO A COLOR THAT WORKS WITH LIGHTOVERRIDE OF 1
		-- local light = GetSeasonManager() and GetSeasonManager():GetWeatherLightPercent() --VANILLA DS CHANGE --OR NOT..
		local light = GetClock() and GetClock().currentColour.x --VANILLA DS CHANGE
		local duskmult = 0 --dusk or 1 --VANILLA DS CHANGE REUSEABLE - MAKE THE SKY RED AT DUSK
		-- if GetClock():IsDusk() then
			-- duskmult = 1 - light
		-- end
		--VANILLA DS CHANGE REUSEABLE
		--ALRIGHT ITS TIME TO DO SOME HECKING MAAAATH --ARE YOU READY FOR SOME PARABOLAS
		duskmult = -((light * light) - light + 0)  --AT LIGHT VALUES OF BOTH 0 & 1, THIS RETURNS 0. BUT RETURNS -0.25 AT LV 0.5 - PERFECT~
		
		--4-25-18 REUSEABLE -- IF INVERSE LIGHT WATCHER, ONLY SHOW AT NIGHT INSTEAD
		if inst.inverselight == true then
			-- light = 1 - light
			light = inst.basetint - light --USE BASETINT SO WE CAN SET EXACTLY WHEN IT STARTS TO SHOW UP
			tint = 1 - tint
			duskmult = 0
		end
		if inst.basetint == 0 then duskmult = 0 end --SO INVISIBLE OBJECTS DONT SHOW UP IN THE SKY AT DUSK
		
		--APPLY LIGHT MULTIPLIER ONLY TO THE RGB COLORS.
		-- sky.AnimState:SetMultColour(inst.r * tint *light,  inst.g*tint*light,  inst.b*tint*light, inst.t*1)
		sky.AnimState:SetMultColour(inst.r * tint *light + (duskmult/2),  inst.g*tint*light+(duskmult/3),  inst.b*tint*light-(duskmult/2), inst.t*1) 
		
		-- !!!! THE GAME SEES A SIGNIFICANT FPS DROP IF THE SKYBOX IS INVISIBLE. A SOLID BLACK DOES DOES THE SAME THING WITHOUT DROPPING PERFORMANCE
	end
		
	-- inst.entity:AddLightWatcher() -- !!!! THESE ARE VERY RESOURCE INTENSIVE!!! ---  OR ARE THEY??
	
	inst:DoPeriodicTask(0.5, function()
		if inst.pausecolorshift == true then
			return end
		
		-- local light = inst.LightWatcher:GetLightValue()
		--VANILLA DS CHANGE - I GUESS THIS IS HOW AMBIENTLIGHT WORKS IN THIS GAME
		local ambientlight = GetClock() and GetClock().currentColour.x or 1
		local light = (ambientlight / 0.78) --0.78 = AVERAGE DAYTIME VALUE
		-- print("LIGHT ", light)
		
		--2-6-18 IF WE IN A CAVE, MAKE IT BLACK
		if TheWorld:HasTag("cave") then 
			UpdateSkyColor(inst, 0) 
			return --AND LEAVE IT AT THAT
		end
		
		if  light < 0.5 and light > 0.02 then --WE DONT REALLY NEED TO WORRY ABOUT SKY COLOR UNTIL NIGHT STARTS TO SETTLE
			UpdateSkyColor(inst, light - 0.05) 
			
		elseif light > 0.5 then 
			UpdateSkyColor(inst, inst.basetint) --SET EM ALL BACK TO NORMAL INSTANTLy
		end
	end)
	
	
	
	
	
	-- inst.entity:SetPristine()

    -- if not TheWorld.ismastersim then
        -- return inst
    -- end
	
	inst.persists = false

    return inst
end

return Prefab( "common/inventory/background", fn, assets) 
