
PrefabFiles = {
	"background", "generic_wall_back",
}

Assets = {
    Asset( "ANIM", "anim/weaponmodel.zip"  ),
	Asset( "ANIM", "anim/handsshoulders.zip"  ),
	Asset( "ANIM", "anim/handsonly.zip"  ),
	Asset( "ANIM", "anim/corner_dude.zip"  ), --DONT FORGET THIS!!
	Asset( "ANIM", "anim/swap_axe.zip"  ), --RIPPED FROM DST ANIM FOLDERS. THESE ONES ARE MUCH HIGHER QUALITY
	Asset( "ANIM", "anim/swap_pickaxe.zip"  ),
	Asset( "ANIM", "anim/swap_spear.zip"  ),
	
	-- Asset( "IMAGE", "data/levels/tiles/grass.tex"  ),
	-- Asset( "ATLAS", "data/levels/tiles/grass.xml"  ),
	
	Asset( "ANIM", "anim/sky_decor.zip"  ), --4-25-18
	
	-- Asset( "IMAGE", "levels/tiles/grass.tex"  ),
	-- Asset( "ATLAS", "levels/tiles/grass.xml"), --OH I GUESS WE DONT NEED THESE (AND ALSO THEY CRASH THE GAME)
	-- Asset( "IMAGE", "levels/tiles/forest.tex"  ),
	-- Asset( "ATLAS", "levels/tiles/forest.xml"),
	-- Asset( "IMAGE", "levels/tiles/water_medium.tex"  ), --THIS SHOULD HELP
	-- Asset( "IMAGE", "levels/tiles/jungle.tex"  ), --THIS SHOULD HELP
}

local require = GLOBAL.require


--ADDS DEVELOPER KEYS. (CRTL-R TO RELOAD SCRIPTS FROM IN GAME)
GLOBAL.CHEATS_ENABLED = false --YOU BETTER NOT FORGET TO DISABLE THESE BEFORE YOU POST IT, YOU DUMMY

GLOBAL.require( 'debugkeys' )
GLOBAL.require("strings")

--OKAY, LETS START ORGANIZING SOME OF THESE
-- if GetModConfigData("LOCO_BUFFER_KEEPS") == true then
	-- --4-24-18 THIS SETTING IS CAUSING TOO MANY ISSUES. SERVER SIDE CAUSES SERIOUS LAG AS PLAYERS DO NOT TRULY LOCOMOTE
	-- --AS OF TODAY, I WILL BE REMOVING THIS SETTING FROM ALL VERSIONS OF THE GAME. (RIP. I PUT A LOT OF TIME INTO IT TOO)
	-- -- modimport 'playercontroller_changes.lua' --THEY CAN CHOOSE NOT TO IMPORT THESE IF WANTED
-- end

local simulate_shading = false
if GetModConfigData("SIMULATE_SHADING") == true then
	simulate_shading = true
end

--DEFINE SOME MODCONFIG VARIABLES UP HERE TO BE USED IN OTHER FILES
GLOBAL.TUNING.FPS_SENSITIVITY = GetModConfigData("SENSITIVITY")
GLOBAL.MODUNLOCKKEY = GetModConfigData("UNLOCKKEY")
GLOBAL.SHADOWREFRESHRATE = GetModConfigData("SHADOWREFRESHRATE")
GLOBAL.WEAPONMODELSIZE = GetModConfigData("WEAPONMODELSIZE")
local unlockprompt = tostring( GLOBAL.STRINGS.UI.CONTROLSSCREEN.INPUTS[1][GLOBAL.MODUNLOCKKEY]) or "ERROR"


--WE NEED A GLOBAL REFERENCE TO THE MODCONFIG DATA TO BE USED OUTSIDE OF MODMAIN
GLOBAL.MODACTIONKEY = GetModConfigData("ACTIONKEY")
--function PlayerController:RemoteStopControl(control)

--WE NEED A GLOBAL REFERENCE TO THE MODCONFIG DATA TO BE USED OUTSIDE OF MODMAIN
GLOBAL.MODINSPECTKEY = GetModConfigData("INSPECTKEY") --WELL, THIS IS USED FOR MORE THAN JUST INSPECTING NOW. SHOULD I CHANGE THE NAME???

--4-20-18 FOV SLIDER FOR THE PROS OUT THERE
GLOBAL.FPSFOV = GetModConfigData("FPSFOV")
GLOBAL.FPSCAMHEIGHT = GetModConfigData("FPSCAMHEIGHT")

-- 4-28-18
GLOBAL.CAMYINVERT = GetModConfigData("CAMYINVERT")

-- 4-25-18 --CLOUDS N STUFF
GLOBAL.SKY_DECOR = GetModConfigData("SKY_DECOR")

--5-8-18 SKY SATURATION
GLOBAL.SKY_SATURATION = GetModConfigData("SKY_SATURATION")

--5-9-18 WEAPNMODEL HANDEDNES
GLOBAL.WEAPONMODEL_HAND = GetModConfigData("WEAPONMODEL_HAND")


--FOR THE REAPPLYGHOSTHANDS TO KNOW IF IT HAS TO RESKIN THE WHOLE BODY
local ghosthands = false

--A DUMB PLACE TO DECLARE OUR PLAYERS PROPERTY IF HOLDING AN ITEM THAT EMITS PARTICALS
local holdingflame = false


--RE-APPLY HIS GOOD-OL FLOATING HANDS SKIN, WITH GLOVES APPLIED
local function ReApplyGhostHands( inst, forcereskin ) --FORCERESKIN IS LIKE THE SAME AS SETTING GHOSTHANDS TO TRUE
	-- print("ReApplyGhostHands")
	
	--WAIT, HIDESYMBOL STRAIGHT UP DOESNT EXIST IN VANILLA DS VERSION??... OKAY THATS A PROBLEM.  BUT ALSO AN EASILY FIXABLE ONE BECAUSE ITS DS LOL
	-- inst.AnimState:HideSymbol("swap_body")
	-- inst.AnimState:HideSymbol("swap_hat")
	--WAIT!! MAYBE OVERRIDE SYMBOL CAN WORK INSTEAD...
	-- inst.AnimState:OverrideSymbol("swap_body")
	-- inst.AnimState:OverrideSymbol("swap_hat")
	-- weaponmodel:GetAnimState():OverrideSymbol("swap_object", swapfile2, swapfile)
	--OH RIGHT, I CAN JUST... DO THIS. IN THIS VERSION
	inst.AnimState:Hide("HAT")
    inst.AnimState:Hide("HAT_HAIR")
	inst.AnimState:Hide("BODY")
	
	--VANILLA DS VERSION  ----I CANT FIND THE TORSO EQUIP SLOT SO...
	inst.AnimState:ClearOverrideSymbol("swap_body") --WE'LL HAVE TO REAPPLY IT LATER
	
	--VANILLA DS VERSION  --JUST GIVE THE GUY A BLANK ANIMATION!!
	-- inst.AnimState:SetBuild("handsonly") --wilson --weaponmodel
	-- inst.AnimState:AddOverrideBuild("handsonly")
	
	-- inst.AnimState:SetSortOrder(0) --FOR US, AT LEAST
	inst.AnimState:SetLayer(GLOBAL.LAYER_WORLD_CEILING) --SO TREES DONT COVER OUR PLAYER MODEL
	
	
	
	
	
	
	-- if (ghosthands == true) or (not forcereskin) then return end --WE'VE ALREADY GOT THE RIGHT SKIN. GO HOME, NOTHING TO SEE HERE
	if not forcereskin then return end
	ghosthands = true --OKAY, WE'LL RUN THIS ONCE AND TELL IT TO STOP AFTER THIS ONE
	print("REAPPLYING THE WHOOOOOLE THING")
	
	
	
	--[[  --WELL, GOODBYE TO THESE I GUESS??
	inst.AnimState:HideSymbol("torso_pelvis")
	inst.AnimState:HideSymbol("torso")
	inst.AnimState:HideSymbol("torso_pelvis_wide")
	inst.AnimState:HideSymbol("torso_wide")
	
	inst.AnimState:HideSymbol("arm_upper")
	inst.AnimState:HideSymbol("arm_upper_skin")
	inst.AnimState:HideSymbol("arm_lower")
	inst.AnimState:HideSymbol("arm_lower_cuff")
	inst.AnimState:HideSymbol("skirt")
	inst.AnimState:HideSymbol("skirt_wide")
	inst.AnimState:HideSymbol("leg")
	inst.AnimState:HideSymbol("leg_boot")
	inst.AnimState:HideSymbol("foot")
	-- inst.AnimState:HideSymbol("hand")
	
	--WHERES THE HEAD??
	inst.AnimState:HideSymbol("cheeks")
	inst.AnimState:HideSymbol("headbase_hat")
	inst.AnimState:HideSymbol("headbase")
	inst.AnimState:HideSymbol("hair_hat")
	inst.AnimState:HideSymbol("hair")
	inst.AnimState:HideSymbol("hairpigtails")
	inst.AnimState:HideSymbol("face")
	inst.AnimState:HideSymbol("beard") --LUCKY GUESS???
	
	inst.AnimState:HideSymbol("tail") --FOUND YA!
	
	--THESE ONES WE ACTUALLY WANT TO SHOW
	inst.AnimState:ShowSymbol("hand")
	]]--
	
	
	--WELL, LETS GIVE IT ANOTHER SHOT...  HAHAAA! CODE CRACKED!
	-- weaponmodel:GetAnimState():OverrideSymbol("swap_object", swapfile2, swapfile)
	local swapfile = "handsonly"
	inst.AnimState:OverrideSymbol("torso_pelvis", swapfile, "cheeks") --LOL CAN I JUST PUT ANYTHING IN HERE TO HIDE IT? --YEP. CHEEKS IT IS
	inst.AnimState:OverrideSymbol("torso", swapfile, "cheeks")
	inst.AnimState:OverrideSymbol("torso_pelvis_wide", swapfile, "cheeks")
	inst.AnimState:OverrideSymbol("torso_wide", swapfile, "cheeks")
	
	--ASSUMING MOST OF THESE EXIST ON THE SINGLEPLAYER CHARACTERS
	inst.AnimState:OverrideSymbol("arm_upper", swapfile, "cheeks")
	inst.AnimState:OverrideSymbol("arm_upper_skin", swapfile, "cheeks")
	inst.AnimState:OverrideSymbol("arm_lower", swapfile, "cheeks")
	inst.AnimState:OverrideSymbol("arm_lower_cuff", swapfile, "cheeks")
	inst.AnimState:OverrideSymbol("skirt", swapfile, "cheeks")
	inst.AnimState:OverrideSymbol("skirt_wide", swapfile, "cheeks")
	inst.AnimState:OverrideSymbol("leg", swapfile, "cheeks")
	inst.AnimState:OverrideSymbol("leg_boot", swapfile, "cheeks")
	inst.AnimState:OverrideSymbol("foot", swapfile, "cheeks")
	inst.AnimState:OverrideSymbol("tail", swapfile, "cheeks")
	
	
	inst.AnimState:OverrideSymbol("cheeks", "handsonly", "cheeks")
	inst.AnimState:OverrideSymbol("headbase_hat", "handsonly", "headbase_hat")
	inst.AnimState:OverrideSymbol("headbase", "handsonly", "headbase")
	inst.AnimState:OverrideSymbol("hair_hat", "handsonly", "hair_hat")
	inst.AnimState:OverrideSymbol("hair", "handsonly", "hair")
	inst.AnimState:OverrideSymbol("hairpigtails", "handsonly", "hairpigtails")
	inst.AnimState:OverrideSymbol("face", "handsonly", "face")
	inst.AnimState:OverrideSymbol("beard", "handsonly", "beard") --LUCKY GUESS???
	
	-- inst.AnimState:OverrideSymbol("tail") --FOUND YA!
	
end


--SHOW NORMAL PLAYER
local function ReApplyNormalBuild( inst )

-- local skip = true
-- if skip == true then return end

	-- print("ReApplyNormalBuild")
	inst.AnimState:SetMultColour(1,1,1,1)
	-- inst.AnimState:ClearSymbolExchanges()
	-- inst.AnimState:ClearAllOverrideSymbols() --NO YOU DUMMY THIS EVEN GETS RID OF THE TOOL
	-- inst.AnimState:SetBuild(tostring(inst.prefabname))  --OH RIGHT, ARENT THEIR BUILDS JUST THEIR PREFAB NAME? THAT WORKS
	-- inst.components.skinner:SetSkinMode("normal_skin")
	-- inst.AnimState:ClearOverrideBuild("handsonly")
	
	-- inst.AnimState:ClearOverrideSymbol("hand")
	
	inst.AnimState:SetLayer(GLOBAL.LAYER_WORLD)
	
	
	--OH! WHAT HAVE WE FOUND HERE?~...
	-- for _,sym in pairs(GLOBAL.CLOTHING_SYMBOLS) do 
		-- -- anim_state:ClearOverrideSymbol(sym)
		-- -- print("CLOTHING_SYMBOLS", sym)
		-- inst.AnimState:ShowSymbol(sym)
	-- end
	
	
	--THE HEAD ISN'T IN THERE, WE HAVE TO SHOW IT OURSELVES
	local function ShowThisSymbol(sym)
		inst.AnimState:ClearOverrideSymbol(sym)  --VANILLA DS CHANGE --WE HAVE TO CLEAR THE OVERRIDE NOW, SINCE WE JUST REPLACED IT WITH AN INVISIBLE ONE
	end
	local headsymbols = {"cheeks", "headbase", "headbase_hat", "hair", "hair_hat", "hairpigtails", "face", "beard"}
	
	for k, v in pairs(headsymbols) do
		ShowThisSymbol(v)
	end
	
	
	--VANILLA DS CHANGE
	inst.AnimState:ClearOverrideSymbol("torso_pelvis")
	inst.AnimState:ClearOverrideSymbol("torso")
	inst.AnimState:ClearOverrideSymbol("torso_pelvis_wide")
	inst.AnimState:ClearOverrideSymbol("torso_wide")
	
	inst.AnimState:ClearOverrideSymbol("arm_upper")
	inst.AnimState:ClearOverrideSymbol("arm_upper_skin")
	inst.AnimState:ClearOverrideSymbol("arm_lower")
	inst.AnimState:ClearOverrideSymbol("arm_lower_cuff")
	inst.AnimState:ClearOverrideSymbol("skirt")
	inst.AnimState:ClearOverrideSymbol("skirt_wide")
	inst.AnimState:ClearOverrideSymbol("leg")
	inst.AnimState:ClearOverrideSymbol("leg_boot")
	inst.AnimState:ClearOverrideSymbol("foot")
	inst.AnimState:ClearOverrideSymbol("tail") --FOUND YA!
	
	--VANILLA DS CHANGE --WE NEED TO RE-EQUIP OUR BODYSLOT ITEM TO GET IT TO SHOW UP AGAIN
	local bodyitem = inst.components.inventory:GetEquippedItem(GLOBAL.EQUIPSLOTS.BODY)
	if bodyitem and bodyitem:IsValid() then
		bodyitem.components.equippable.onequipfn(bodyitem, inst)
	end
	
	
	--VANILLA DS CHANGE -
	inst.AnimState:Show("HAT")
	
end




local function ToggleCamView()
	if not GLOBAL.GetPlayer() then return end

	local player = GLOBAL.GetPlayer()
	local TheInput = GLOBAL.TheInput
	local TheWorld = GLOBAL.GetWorld()
	if player.FPSmode == true then
		
		--VANILLA DS CHANGE -- HOLD ON! IF THE HUD DOESNT EXIST YET, GIVE THEM A SEC TO LOAD IT IN AND THEN TRY AGAIN
		-- if not player.HUD then
			-- player:DoTaskInTime(0, function()
				-- ToggleCamView() --CAN YOU EVEN CALL A LOCAL FROM WITHIN ITSELF?   --NO. THE ANSWER IS NO. YOU CANT
			-- end)
			-- return end --CANCEL THE REST OF THE FN! THE PLAYER ISNT READY YET
			
		player.FPSmode = false
		GLOBAL.TheCamera.holdq = true
		GLOBAL.TheCamera:SetNewDefault()
		player.HUD.controls.playermodel:Hide() --HIDE THE HUD AND SHOW THE PLAYERMODEL
		-- player:PushEvent("updateweaponmodeldirty") 
		player.HUD.controls.activeinvitem:Hide()
		player.HUD.controls.crafttabs:Show()
		player.floorret.AnimState:SetMultColour(0,0,0,0)
		-- player:Show()
		player.AnimState:SetMultColour(1,1,1,1)
		ReApplyNormalBuild(player)
		if player.components.transparentobstacles then
			player.components.transparentobstacles.is_in_fps = false
			-- player.components.transparentobstacles.darkglow.AnimState:SetMultColour(0,0,0,0)
			-- player.components.transparentobstacles.darkfloor.AnimState:SetMultColour(0,0,0,0)
			player.components.transparentobstacles.darkglow.darknessvalue = 0 --4-24-18 TURN THESE BOYS BACK OFF, SINCE THEIR SHADOW VALUE ONLY UPDATES IN FIRST PERSON
			player.components.transparentobstacles.darkfloor.darknessvalue = 0
		end
		--HIDE THE SKYBOXES
		player.components.retmanager:HideSkyboxes()
		player.components.retmanager.floorbeam.AnimState:SetMultColour(0,0,0,0) --DS CHANGE REUSEd
		
		
	else
		player.FPSmode = true
		GLOBAL.TheCamera:SetFPSMode()
		ReApplyGhostHands(player, true)
		player.AnimState:SetMultColour(0,0,0,0) --JUST HOPE THEY ARENT MOUNTED
		-- player.components.talker.widget:SetFontSize(50)
		player.recentermouse = true
		player.components.retmanager:ShowSkyboxes()
		player:PushEvent("updateweaponmodeldirty")  --GUESS THIS STILL COMES IN HANDY CLIENTSIDE!
		if player.components.transparentobstacles then
			player.components.transparentobstacles.is_in_fps = true
		end
		
		--4-24-18 LETS ADD AN OPTION TO MAKE WAVES MORE BAREABLE TO LOOK AT
		--SINGLEPLAYER DOESN'T HAVE THHIS VERSION??? WHAT???
		-- if TheWorld.WaveComponent then --SINCE CAVES DONT HAVE A WAVE COMPONENT
			-- TheWorld.WaveComponent:SetWaveParams(12, 0.7, -2)  --( x-stretch , z-spacing , height)
			-- TheWorld.WaveComponent:SetWaveSize(200, 3)   -- (length , y-stretch)
		-- end
	end
end








--SHOULDN'T WE GET RID OF THESE FOR THE SINGLEPLAYER VERSION?...     --NAH...
--SINCE THE PLAYER BEING INVISIBLE IS ONLY A PROBLEM TO THE HOST, CAN'T WE JUST USE NETVARIABLES TO PUT THEM BACK?
local function reapplynormalbuilddirty(inst)
	if GLOBAL.GetPlayer() and inst ~= GLOBAL.GetPlayer() then
		ReApplyNormalBuild(inst)
		-- print("DEAR GOD MAN PUT THOSE BACK ON")
	end
end

local function reclothepostinit(inst)
	inst.clothenetvar = GLOBAL.net_string(inst.GUID, "perhapsthis.text", "reclothehost")
	--SO DO WE ONLY NEED THE EVENT LISTENER FOR THIS ONE?? OR THE NET VARIABLE?
	if not GLOBAL.TheNet:IsDedicated() then
		inst:ListenForEvent("reclothehost", reapplynormalbuilddirty) --HOST IS TAKING HIS CLOTHES OFF. ON ALL CLIENTS, RUN A SCRIPT THAT PUTS THEM BACK ON
	end
end
-- AddPlayerPostInit(reclothepostinit)

--3=6=18 FOR THE HOST-ADDON, WE PROBABLY WONT BE ABLE TO EASILY LISTEN FOR CLIENTRESKINS. INSTEAD, JUST RUN A RECLOTHE EVERY FEW FRAMES AND CALL IT A DAY. GOOD ENOUGH
--THIS IS PROBABLY THE ONLY THING WE WILL NEED, BESIDES A COPY OF THE ReApplyNormalBuild FUNCTION.
local function hostreclothe(inst)
	inst:DoPeriodicTask(10*GLOBAL.FRAMES, function() --EVERY 10 FRAMES (1/3RD OF A SECOND. SEEMS CLOSE ENOUGH)
		if GLOBAL.GetPlayer() and inst ~= GLOBAL.GetPlayer() then
			ReApplyNormalBuild(inst)
		end
	end)
	
	inst:DoPeriodicTask(2, function() --EVERY 2 SECONDS
		if GLOBAL.GetPlayer() and inst ~= GLOBAL.GetPlayer() then
			inst.AnimState:SetLayer(GLOBAL.LAYER_WORLD) --OH YEA, AND THIS TOO. BUT MUCH LESS IMPORTANT, SO AT A LOWER REFRESH RATE
		end
	end)
end
-- AddPlayerPostInit(hostreclothe)



local function CenterReticule(class)
	
	local UIAnim = require "widgets/uianim"
	local Image = require "widgets/image"
	require "widgets/widget"
	
	
	class.playermodel = class:AddChild(UIAnim())
	
	class.playermodel:GetAnimState():SetBank("corner_dude") --corner_dude
    class.playermodel:GetAnimState():SetBuild("weaponmodel") --wilson --weaponmodel
    class.playermodel:GetAnimState():PlayAnimation("idle", true)
	
	
	--AND... A MIRORED VERSION?
	class.playermodel:SetHAnchor(0) --ANCHOR_LEFT
    class.playermodel:SetVAnchor(2) --ANCHOR_BOTTOM
	class.playermodel:SetPosition(0,-350, 0)
	-- class.playermodel:SetScaleMode(GLOBAL.SCALEMODE_PROPORTIONAL) --SCALEMODE_PROPORTIONAL ---NNNOPE
	
	--2-18-18 LETS TRY THIS AGAIN... --NO YOU CANT DO THIS HERE YOU DUMMY
	-- class.playermodel:SetVRegPoint(GLOBAL.ANCHOR_BOTTOM)
    -- class.playermodel:SetHRegPoint(GLOBAL.ANCHOR_MIDDLE)
	
	
	class.playermodel:SetScale(-3.0, 3.5, 2)
	
	--[[
	--1366 = width
	local w,h = GLOBAL.TheSim:GetScreenSize()
	-- print("SCREEN SIZE", w)
	class.playermodel:SetPosition(0,-350* (w/1366), 0)
	class.playermodel:SetScale(-3.0 * (w/1366), 3.5* (w/1366), 2)
	]]
	
	
	--MONITOR SCREEN WIDTHS ARE ALL OVER THE PLACE. SCALE IT BY HEIGHT INSTEAD
	local w = GLOBAL.RESOLUTION_X
	local h = GLOBAL.RESOLUTION_Y
	-- print("SCREEN SIZE", w)
	w = w * GLOBAL.WEAPONMODELSIZE --CHAGE THE SCALE OF THE ON-SCREEN MODEL TO MATCH THE USER'S CHOICE
	h = h * GLOBAL.WEAPONMODELSIZE
	class.playermodel:SetPosition(0,-350* (w/1366), 0)
	-- class.playermodel:SetScale(-3.0 * (w/1366), 3.5* (w/1366), 2)
	--WE SHOULD SCALE THE WEAPON MODEL BASED ON HEIGHT, NOT WIDTH
	-- class.playermodel:SetScale(-3.0 * (h/720), 3.5* (h/720), 2) --REUSEd - BASED ON SCREEN HIEGHT INSTEAD OF WIDTH
	--5-9-18 ADDED WEAPONMODEL_HAND MULTIPLIER
	class.playermodel:SetScale((-3.0 * GLOBAL.WEAPONMODEL_HAND) * (h/720), 3.5* (h/720), 2) --REUSEd - BASED ON SCREEN HIEGHT INSTEAD OF WIDTH
	
	-- class.playermodel.bob = function()  --CAN... I DO THIS? IS THIS A THING? LETS FIND OUT	--NNNNNOPE
		-- class.playermodel:SetPosition(0,-350* (w/1366) + GLOBAL.TheCamera.boby, 0)
	-- end
	
	
	local Text = require "widgets/text"
	
	class.sidetext = class:AddChild(Text(GLOBAL.NUMBERFONT, 40))
	
	-- class.sidetext:SetHAlign(1) --ANCHOR_LEFT
	-- class.sidetext:SetVAlign(0) --ANCHOR_MIDDLE
	class.sidetext:SetHAnchor(1) --ANCHOR_LEFT
    class.sidetext:SetVAnchor(0) --ANCHOR_MIDDLE
	class.sidetext:SetPosition(35, 0)
	class.sidetext:SetScaleMode(GLOBAL.SCALEMODE_PROPORTIONAL)
	-- class.sidetext:SetHorizontalSqueeze(1)
	-- class.sidetext:SetString("Hold (Q) to Un-Lock Mouse") --WELL, IT MIGHT NOT BE Q
	class.sidetext:SetString("Hold (" .. unlockprompt ..") to Un-Lock Mouse") --DECLARED AT THE TOP OF THE PAGE FROM MODSETTINGS
	
	-- class.sidetext:SetScaleMode(1)
	class.sidetext:SetRotation(90)
	
	--MAKE THE HELP TEXT DIFFERENT IF A CONTROLLER IS PLUGGED IN
	if GLOBAL.TheInput:ControllerAttached() then
		class.sidetext:SetString("Use LB/RB To Scroll Inventory")
	end
	
	-- class.playermodel:SetRotation(10)
	
	
	
	
	
	--A SLOT FOR WHEN HOLDING AN INVENTORY ITEM IN THE ACTIVE SLOT
	-- class.activeinvitem = class:AddChild(Image("images/inventoryimages.xml", "anim/axe.zip", "default.tex"))
	class.activeinvitem = class:AddChild(Image("images/inventoryimages.xml", "axe.tex"))
	-- class.activeinvitem:SetTexture("images/inventoryimages.xml", "anim/axe.zip")
	class.activeinvitem:SetHAnchor(2) --2 ANCHOR_RIGHT
    class.activeinvitem:SetVAnchor(GLOBAL.ANCHOR_BOTTOM) --ANCHOR_MIDDLE
	
	class.activeinvitem:SetVRegPoint(GLOBAL.ANCHOR_BOTTOM)
    class.activeinvitem:SetHRegPoint(GLOBAL.ANCHOR_RIGHT)
	class.activeinvitem:SetPosition(-50, -20) 
	-- class.activeinvitem:SetScaleMode(GLOBAL.SCALEMODE_PROPORTIONAL)  --NOPE
	class.activeinvitem:SetScale(6, 6, 6)
	-- MoveToBack() --NOTE- THIS WILL PREVENT YOU FROM ACCESSING YOUR EQUIP SLOTS IF NOT MOVED TO BACK
	class.activeinvitem:Hide() --AND THEN JUST HIDE IT BECAUSE WE DONT HAVE ANYTHING YET
	
	

	--MAKE SOME BLOOD DIRECTIONAL SPLASHES
	class.bloodsplash_down = class:AddChild(UIAnim())
	class.bloodsplash_down:GetAnimState():SetBank("background_image") --corner_dude
    class.bloodsplash_down:GetAnimState():SetBuild("background_image") --wilson --weaponmodel
    class.bloodsplash_down:GetAnimState():PlayAnimation("sidefade_idle", false)
	class.bloodsplash_down:GetAnimState():SetMultColour(1,0,0,0.7)
	class.bloodsplash_down:SetHAnchor(0) --ANCHOR_MIDDLE
    class.bloodsplash_down:SetVAnchor(2) --ANCHOR_BOTTOM
	class.bloodsplash_down:SetScale(30, 1.2, 3)
	-- class.bloodsplash_down:SetPosition(0,-350, 0)
	
	--AND FOR THE OTHER ANGLES TOO
	class.bloodsplash_left = class:AddChild(UIAnim())
	class.bloodsplash_left:GetAnimState():SetBank("background_image") --corner_dude
    class.bloodsplash_left:GetAnimState():SetBuild("background_image") --wilson --weaponmodel
    class.bloodsplash_left:GetAnimState():PlayAnimation("sidefade_idle", false)
	class.bloodsplash_left:GetAnimState():SetMultColour(1,0,0,0.6)
	class.bloodsplash_left:SetHAnchor(1) --ANCHOR_LEFT
    class.bloodsplash_left:SetVAnchor(0) --ANCHOR_MIDDLE
	class.bloodsplash_left:SetRotation(90)
	class.bloodsplash_left:SetScale(5, 1.2, 1)
	
	
	class.bloodsplash_right = class:AddChild(UIAnim())
	class.bloodsplash_right:GetAnimState():SetBank("background_image") --corner_dude
    class.bloodsplash_right:GetAnimState():SetBuild("background_image") --wilson --weaponmodel
    class.bloodsplash_right:GetAnimState():PlayAnimation("sidefade_idle", false)
	class.bloodsplash_right:GetAnimState():SetMultColour(1,0,0,0.6)
	class.bloodsplash_right:SetHAnchor(2) --ANCHOR_RIGHT
    class.bloodsplash_right:SetVAnchor(0) --ANCHOR_MIDDLE
	class.bloodsplash_right:SetRotation(270)
	class.bloodsplash_right:SetScale(5, 1.2, 1)
	
	
end

-- AddClassPostConstruct("widgets/statusdisplays", CenterReticule)
AddClassPostConstruct("widgets/controls", CenterReticule) --WE MAY NEED TO THROW THIS ON INVENTORY TO KEEP IT FROM COVERING IT UP



local function BloodSplashFade(inst, direction)
    local blooddown = inst.HUD.controls.bloodsplash_down
	local bloodleft = inst.HUD.controls.bloodsplash_left
	local bloodright = inst.HUD.controls.bloodsplash_right
	
	if direction == "down" then
		blooddown:GetAnimState():PlayAnimation("sidefade", false)
	elseif direction == "left" then
		bloodleft:GetAnimState():PlayAnimation("sidefade", false)
	elseif direction == "right" then
		bloodright:GetAnimState():PlayAnimation("sidefade", false)
	end
end





local function AddToggleButton(class)
	--I BET I CAN GET REAL "PROPER" WITH THIS. MAXIMUM COMPATIBILITY!
	
	class.cambutton = class.menu:AddItem("Switch Camera", nil, GLOBAL.Vector3(0,0,0)) --, "carny_xlong", nil)
	
	class.cambutton:SetOnClick(function() 
		ToggleCamView()
		-- class:unpause() --NOT IN THE VANILLA VERSION
		GLOBAL.TheFrontEnd:PopScreen(class) 
		if not class.was_paused then 
			GLOBAL.SetPause(false) 
		end 
		GLOBAL.GetWorld():PushEvent("continuefrompause")
	end)
	
end
AddClassPostConstruct("screens/pausescreen", AddToggleButton) --OHHH ITS IN REDUX
--DST - DS VANILLA CHANGE - REMOVE /REDUX/ FOR THE SINGLEPLAYER VERSION


--VANILA DST CHANGE -- ADD IN DST'S "HASFOCUS" UTILITY TO THE PLAYERHUD
local function AddToggleButton(class)

	--PULLED STRAIGHT OUTTA DST FOR ITS GREAT UTILITY --... THIS IS ALLOWED, RIGHT???
	function class:HasInputFocus()
		--We're checking that the active screen is NOT us, because HUD
		--is always active, and we're saying that it locks input focus
		--when anything else is active on top of it.
		local active_screen = GLOBAL.TheFrontEnd:GetActiveScreen()
		return (active_screen ~= nil and active_screen ~= class)
			or (class.controls ~= nil and (class.controls.inv.open or class.controls.crafttabs.controllercraftingopen))
			or class.modfocus ~= nil
	end
	
end
AddClassPostConstruct("screens/playerhud", AddToggleButton)


--OKAY I REALLY NEED THIS THING IN HERE
local function normalize(angle)
    while angle > 360 do
        angle = angle - 360
    end
    while angle < 0 do
        angle = angle + 360
    end
    return angle
end



local function FloorReticule( inst )

	-- local inst = inst.owner --NOW THAT ITS KIND OF A WIDGET
	-- if inst ~= GLOBAL.GetPlayer() then return end --ONLY THE OWNER GETS THIS CODE. EVERYONE ELSE BACK OFF.
	
	inst.floorret = GLOBAL.SpawnPrefab("reticule")
	inst.floorret.AnimState:SetMultColour(1,1,1,0.5)
	inst.floorret.AnimState:SetLightOverride(1)
	-- inst.floorret:AddTag("NOBLOCK") --VANILLA DS CHANGE - FOR BUILDABLES SEEING CURSOR AS BEING IN THE WAY
	-- inst.floorret:AddTag("NOCLICK")
	-- inst.floorret.Transform:SetScale(2,2,2)
	
	inst.FPSmode = true
	
	inst:AddComponent("retmanager")
	
	--IF SIMULATE SHADING IS ENABLED IN MODSETTINGS, IT ENABLES BOTH OF THESE
	if simulate_shading == true then
		inst:AddComponent("modelambient")
		inst:AddComponent("transparentobstacles") --YO THIS IS SUCH A GOOD IDEA I CAN'T BELEIVE I NEVER THOUGHT OF IT
	end
	
	inst.DynamicShadow:Enable(false) --VANILLA DS CHANGE
	
	inst.recentermouse = false --TO SKIP THE MOUSEMOVE SCREEN LOCK ONE TIME AFTER MOVING AN UNLOCKED MOUSE
	inst.pausewheel = false --BECAUSE FOR SOME DUMB REASON, ONE SCROLL OF THE MOUSEWHEEL SCROLLS TWICE
	
	
	--SOME BASIC EVENTLISENERS TO HANDLE SPECIFIC CAMERA MOVEMENTS TO MATCH SPECIFIC EVENTS
	
	inst:ListenForEvent("dismounted", function() 
		if inst.FPSmode == false then return end
		-- GLOBAL.TheCamera:EnableTempGains()
		GLOBAL.TheCamera:SetFPSMode() 
	end)
	
	
	inst:ListenForEvent("mounted", function() 
		if inst.FPSmode == false then return end
		--MAKE THEM LOOK UP REAL QUICK AS IF THEY WERE GETTING ONTO IT
		GLOBAL.TheCamera.pitch = -90 --OR DONT, OKAY
		GLOBAL.TheCamera:Update(0)
		GLOBAL.TheCamera:EnableTempGains()
		GLOBAL.TheCamera:SetRiderMode()
		GLOBAL.TheCamera.pitch = -45 --HOW ABOUT NOW?
	end)
	
	
	--SHIPWRECKED DS CHANGE -
	inst:ListenForEvent("mountboat", function() 
		if inst.FPSmode == false then return end
		GLOBAL.TheCamera:SetSailorMode()
	end)
	
	inst:ListenForEvent("dismountboat", function() 
		if inst.FPSmode == false then return end
		GLOBAL.TheCamera:SetFPSMode()
		GLOBAL.TheCamera.pitch = 20 --LOOK DOWN A BIT REAL QUICK. IT'S LESS JARRING
	end)
	
	
	--EVERY TIME WE SELECT SOMETHING FROM OUR INVENTORY, BRING IT UP IN OUR RIGHT HAND
	inst:ListenForEvent("newactiveitem", function()
		--TODO --:TakeActiveItemFromEquipSlot(eslot)
		if inst.FPSmode == false or not inst.HUD then return end --SAME OL SAME OL
		local invitem = inst.components.inventory:GetActiveItem()
		local righthand = inst.HUD.controls.activeinvitem
		if invitem ~= nil then
			righthand:SetTexture(invitem.components.inventoryitem:GetAtlas(), invitem.components.inventoryitem:GetImage())
			righthand:Show()
		else
			righthand:Hide()
		end
	end)
		
		
	--ZOOM OUT JUST A BIT TO SHOW THE PLAYER'S TRANSITION BETWEEN FORMS OR LIFE/DEATH
	local function TempThirdPerson()
		if inst.FPSmode == true then
			ReApplyNormalBuild( GLOBAL.GetPlayer() )
			GLOBAL.TheCamera:TempTransformSpotlight()
			-- inst:DoTaskInTime(2, function() 
				 -- self:SetFPSMode()
			-- end)
		end
	end
	
	inst:ListenForEvent("transformnormal", TempThirdPerson)
	inst:ListenForEvent("transformwere", TempThirdPerson)
	inst:ListenForEvent("transform_person", TempThirdPerson)
	inst:ListenForEvent("transform_werebeaver", TempThirdPerson)
	inst:ListenForEvent("respawn", TempThirdPerson) --4-26-18 VANILLA DS CHANGE
	
	inst:ListenForEvent("respawnfromghost", function()
		TempThirdPerson()
		if inst.FPSmode == true then 
			inst:DoTaskInTime(6, function() 
				GLOBAL.TheCamera:SetFPSMode() 
				ReApplyGhostHands( inst, true )
			end)
		end
	end)
	
	inst:ListenForEvent("death", function() 
		TempThirdPerson()
		if inst.FPSmode == true then 
			inst.HUD.controls.playermodel:GetAnimState():Hide("ARM_carry")
			inst:DoTaskInTime(3, function() 
				ReApplyGhostHands( inst, true ) --OTHERWISE YOU'LL SEE WHATEVER WAS JUST IN YOUR HANDS
			end)
		end
	end)
	
	
	--4-12-18 CUSTOM CASE FOR MOD CHARACTERS SHOWING SPECIAL ANIMATIONS I SUPPOSE. --REUSEd
	inst:ListenForEvent("customzoom", function() 
		TempThirdPerson()
		inst:AddTag("show_fp_anim")
		if inst.FPSmode == true then 
			inst.HUD.controls.playermodel:GetAnimState():Hide("ARM_carry")
			inst:DoTaskInTime(2, function() 
				ReApplyGhostHands( inst, true ) --OTHERWISE YOU'LL SEE WHATEVER WAS JUST IN YOUR HANDS
				inst:RemoveTag("show_fp_anim")
			end)
		end
	end)
	
	
	
	--SHOW DAMAGE SPLASH IN THE DIRECTION WE ARE GETTING HIT FROM
	local function OnAttacked(inst, data)
		if inst.FPSmode == false then return end
		local attacker = data.attacker or nil
		
		
		--OH. CLIENTS HAVE NO WAY OF GETTING THEIR ATTACKER... THIS IS A PROBLEM.
		-- if not GLOBAL.TheWorld.ismastersim then
			--OKAY. WE'RE GONNA HAVE TO DO A LITTLE BIT OF GUESSING HERE... GET THE CLOSEST POSSIBLE SUSPECT THAT ISN'T AN ALLY
			local instx, insty, instz = inst.Transform:GetWorldPosition()
			local suspects = TheSim:FindEntities(instx, insty, instz, 10)
			local primesuspect = nil --THE OBJECT MOST LIKELY TO BE ATTACKING US
			
			for k, v in pairs(suspects) do
				if not inst.components.combat:IsAlly(v) and not v:HasTag"prey" then
					primesuspect = v
					break --CASE CLOSED! BRING EM IN BOYS.   
					--YEA SURE, THATS HOW THE JUSTICE SYSTEM WORKS RIGHT? NO NEED TO INTERVIEW THE OTHER SUSPECTS OR ANYTHING...
				end
			end
			attacker = primesuspect
		-- end
		
		
		if not attacker then return end --NO SUSPECTS FOUND. FORGET IT
		
		
		
		local att_x, att_y, att_z = attacker.Transform:GetWorldPosition()
		local angle = inst:GetAngleToPoint(att_x, att_y, att_z)
		local camangle = GLOBAL.TheCamera:GetHeadingTarget()
		angle = normalize(180 - angle)
		
		local hitangle = math.abs(angle - camangle) --THE ANGLE IN WHICH WE ARE FACING FROM THE SOURCE OF DAMAGE
		print("GETTING HIT FROM ", hitangle)
		if hitangle <= 45 or hitangle >= 315 then --IF THE SOURCE OF DAMAGE IS IN OUR SIGHTS
			--DO NOTHING
		elseif hitangle <= 225 and hitangle >= 135 then --IF WITHIN 90 DEGREES BEHIND US
			BloodSplashFade(inst, "down")
		elseif hitangle >= 225 then
			BloodSplashFade(inst, "right")
		elseif hitangle <= 135 then
			BloodSplashFade(inst, "left")
		end
		
	end
	
	-- inst:ListenForEvent("attacked", OnAttacked, inst._parent)
	inst:ListenForEvent("attacked", OnAttacked, inst._parent)
	
	
	
	
	
	
	
	
	
	
	
	
	local modeloverrides = {"mine_start", "mine", "chop_start", "chop", "hammer_start", "hammer", "terraform", "dig_start", "dig", "bugnet_start", "bugnet",
	"dolongaction", "throw", "catch_pre", "attack",
	"fishing_pre", "fishing", "fishingpst", "fishing_nibble", "fishing_strain", "catchfish", "loserod",
	"mount", "dismount", "mounted_idle", "graze", "graze_empty", "bellow", "shake", "falloff", "bucked", "unsaddle"
	}
	
	
	local function CheckModelOverrides(state) --RETURNS TRUE IF THE STATE IS FOUND IN THE LIST OF OVERRIDE STATES ABOVE
		local override = false
		
		for i, v in ipairs(modeloverrides) do
			if state == v then
				override = true
			end
		end
		
		if GLOBAL.GetPlayer().components.rider and GLOBAL.GetPlayer().components.rider:GetMount() ~= nil then
			override = true  --JUST ALWAYS SHOW THE SPRITE IF A MOUNT EXISTS. EVEN BOTH, IF NEEDED
			-- print("HERES MY AMINAL ", GLOBAL.GetPlayer().components.rider:GetMount())
		end
	
		return override
	end
	
	
	

	
	
	
	
	--LOOKS AT PLAYER'S CURRENT ANIMATION AND DECIDES WHAT HUD ACTIONS TO DISPLAYE
	
	--IF PLAYING ANY OF THESE ANIMATIONS, SHOW THE IN-GAME MODEL INSTEAD OF THE HUD WEAPONMODEL.
	local modelanimoverrides = {"bugnet", "terraform", "atk_pre", "atk", "unsaddle_pre", "unsaddle", "whip_pre", "whip", "punch", "dart_pre", "dart", "throw", "catch_pre", "catch",
	"flute", "horn", "bell", "player_atk_pre", "player_atk", "attack_book", "woodie_chop_loop", "woodie_chop_pre", "woodie_chop_atk_pre", "bedroll", "bedroll_sleep_loop", "teleport", "fan", 
	"rebirth", "amulet_rebirth", "brace", "transform_pre", "transform_pst", "transform_end", "death", "death2", "shock", "book",
	"bedroll_wakeup", "wakeup", "hide", "hide_idle",
	"pickaxe_loop", "shovel_loop", "pickaxe_pre", "chop_pre", "shovel_pre", "build_loop", "build_pre", "chop_loop", --VANILLA DS CHANGE - WE INCLUDE CHOP_LOOP NOW
	"chop_lag", "woodie_chop_lag", "pickaxe_lag", "atk_lag", "player_atk_lag", "fishing_lag", --DON'T FORGET CLIENT ONLY STATES
	"heavy_eat", "eat_pre", "eat", "distressed_loop",
	"fishing_pre", "fishing_cast", "fishing_idle", "fishing_pst", "fish_catch", "fish_nocatch", "bite_light_pre", "bite_light_loop",
	"bucked", "bucked_pst", "fall_off", "dismount", "buck", "buck_pst",
	"speargun", "shoot", "telescope", "scroll", "scroll_pst", --VANILLA DS CHANGE -- SOME SHIPWRECKED ANIMATIONS!!
	"tamp_pre", "tamp_loop", "lens"  --HAMLET DS CHANGE -12-8--18  -- +cut added below
	}
	
	--TO MORE EASILY ADD PRE/LOOP/PST TENSES TO ANY MULTI STAGE VERBS
	local function AnimTenseGenerator(action)
		local animname = tostring(action)
		table.insert(modelanimoverrides, animname.."_pre")
		table.insert(modelanimoverrides, animname.."_loop")
		table.insert(modelanimoverrides, animname.."_pst")
	end
	
	local actiontables = {"bugnet", "bite_light", "bite_heavy", "gift_open", "wrap", "channel", "transform", "cut"}
	
	for i, v in ipairs(actiontables) do
		AnimTenseGenerator(v)
	end
	
	--ALL OF THESE ANIMATIONS SHOULD TRIGGER THE WEAPNMODEL TO PLAY THE "QUICKEAT" ANIMATION INSTEAD
	local weapontwitchoverrides = {"quick_eat_pre", "quick_eat", "give", "pickup", "catch",
	"pickaxe_pst", "chop_pst", "shovel_pst", "build_pst", "pickup_pst", "hide"}
	
	--AND YET ANOTHER TABLE OF ANIMS TO PLAY INVOLVING BRINGING THE WEAPON UP FROM BOTTOM SCREEN
	local weaponlifts = {"pickaxe_pst", "chop_pst", "shovel_pst", "build_pst"}
	--OH... THERE IS NO CHOP_PST...
	
	
	
	local function CheckModelAnimOverrides(animcheck) --RETURNS TRUE IF THE ANIMATION IS FOUND IN THE LIST ABOVE
		local override = false
		local weaponmodel = GLOBAL.GetPlayer().HUD.controls.playermodel
		
		-- ALWAYS CHECK FOR HEADBOB ANIMATION
		if animcheck:IsCurrentAnimation("run_loop") then
			-- GLOBAL.TheCamera:BobHead() --BOB YOUR HEAD
			if GLOBAL.GetPlayer().components.rider and GLOBAL.GetPlayer().components.rider:GetMount() ~= nil then
				GLOBAL.TheCamera:BobHead(nil, 0.4, 6) --BOB WITH EXTRA HEIGHT
				GLOBAL.TheCamera.bobhead_enabled = true --ONLY BOB THE CAMERA IF WE'RE ON A BEEFALO
			else
				GLOBAL.TheCamera:BobHead() --BOB YOUR HEAD
				GLOBAL.TheCamera.bobhead_enabled = false
			end
			--ALRIGHT. I HAVE TO DO IT. IT JUST LOOKS TOO WOBBLY.
			-- if weaponmodel:GetAnimState():GetCurrentAnimationTime() >= (21 * GLOBAL.FRAMES) and  weaponmodel:GetAnimState():GetCurrentAnimationTime() <= (50 * GLOBAL.FRAMES) then
				-- weaponmodel:GetAnimState():SetTime(54 * GLOBAL.FRAMES)
			-- end
			-- weaponmodel:GetAnimState():PushAnimation("sad") --TBH, JUST JUST LOOKS A LITTLE LESS WOBBLY THAN IDLE
		end
		
		if animcheck:IsCurrentAnimation("run_pst") then
			GLOBAL.TheCamera:BobHead("down") --TELL IT TO HEAD BACK DOWN, NO MATTER WHERE IN THE ARC IT IS
		end
		
		
		if GLOBAL.GetPlayer().components.rider and GLOBAL.GetPlayer().components.rider:GetMount() ~= nil then
			return true  --JUST ALWAYS SHOW THE SPRITE IF A MOUNT EXISTS. EVEN BOTH, IF NEEDED
		end
		
		--VANILLA DS CHANGE -- AND BOATS TOO!!
		if GLOBAL.GetPlayer().components.driver and GLOBAL.GetPlayer().components.driver.driving == true then
			--IF SAILING, BOB LIKE CRAZY --EH, THIS KINDA MAKES IT GLITCH OUT A BIT...
			if GLOBAL.GetPlayer().sg:HasStateTag("moving") then
				GLOBAL.TheCamera:BobHead(nil, 0.07, 0.3) 
				GLOBAL.TheCamera.bobhead_enabled = true
				
				--ADD OUR MOVEMENT TO THE CAM OFFSET DISTANCE SO IT LOOKS LESS CHOPPY AND LAGGY WHILE SAILING
			else
				GLOBAL.TheCamera:BobHead(nil, 0.04, 0.1)
				GLOBAL.TheCamera.bobhead_enabled = true
			end
			--MAYBE BOB DOWN AT SAIL_STOP STATE
			
			--SHIPWRECKED DS CHANGE -- IF WE HAVE A SAIL EQUIPPED, IT WILL COVER HALF OUR SCREEN, SO LEAN TO THE SIDE A BIT
			if GLOBAL.GetPlayer().components.driver.vehicle.components.drivable:GetIsSailEquipped() 
			and GLOBAL.GetPlayer().components.retmanager:IsPlayerLookingInDirection(GLOBAL.GetPlayer(), GLOBAL.GetPlayer().Transform:GetRotation(), 90) then
				GLOBAL.TheCamera:SetCameraLean(0.5)
				-- print("LEANING")
			else
				GLOBAL.TheCamera:SetCameraLean(0) --WISH WE COULD MAKE THIS RUN ONLY ONCE WHEN UNEQUIPPING A SAIL AND LEAVE IT ALONE
			end
			
			return true  --JUST ALWAYS SHOW THE SPRITE IF A MOUNT EXISTS. EVEN BOTH, IF NEEDED
		end
		
		
		--SPECIAL CASES FIRST! LET US SKIP THESE GIANT TABLE COMBING IF WE HAVE TO
		--STAFFS
		if animcheck:IsCurrentAnimation("staff") or animcheck:IsCurrentAnimation("staff_pre") then
			if (weaponmodel:GetAnimState():IsCurrentAnimation("angry") == false) then
				weaponmodel:GetAnimState():PlayAnimation("angry")
				weaponmodel:GetAnimState():PushAnimation("idle")
				return true --JUST RETURN EARLY. NO NEED TO RUN THROUGH ALL THOSE TABLES NOW
			end
		end
		
		
		--IF OUR PLAYER HAS JUST FINISHED TRANSFORMING/REVIVING AND SHOULD RETURN TO THE FIRST PERSON CAMERA STATE
		if animcheck:IsCurrentAnimation("transform_pst") or animcheck:IsCurrentAnimation("transform_end") or animcheck:IsCurrentAnimation("corpse_revive") then
			GLOBAL.TheCamera:SetFPSMode() --RETURN THEIR CAMERA TO NORMAL VIEW
		end
		
				
		--IF WHEREBEAVER, DONT PLAY THE ANIMATION. HE TAKES UP THE WHOLE SCREEN. SHAKE CAMERA INSTEAD
		if inst:HasTag("beaver") then
			if (animcheck:IsCurrentAnimation("atk_pre") or animcheck:IsCurrentAnimation("atk_lag")) then
				inst:ShakeCamera(GLOBAL.CAMERASHAKE.FULL, .4, .02, 0.2) --mode, duration, speed, scale, source_or_pt, maxDist
			elseif animcheck:IsCurrentAnimation("eat_pre") or animcheck:IsCurrentAnimation("eat_lag") then
				inst:ShakeCamera(GLOBAL.CAMERASHAKE.FULL, .1, .02, 0.1) --NOT QUITE AS HEAVY FOR EAT
			-- else
				-- return false --HE MUST BE TRANSFORMING. LET IT RIDE
			end
			
			if (animcheck:IsCurrentAnimation("transform_pre") or animcheck:IsCurrentAnimation("transform_pst") or animcheck:IsCurrentAnimation("transform_end")) then
				return true --ONLY SHOW BEAVER IF HE'S TRANSFORMING
			else
				return false
			end
		end
				
		
		--VANILLA DS CHANGE -- APPARENTLY "GetCurrentAnimationTime" DOESNT EXIST IN THIS VERSION, SO IT CANT BE USED :C
		--OKAY, I GUESS WE NEED ONE SPECIFICALLY FOR CHOP_LOOP THEN... I MEAN ITS SUCH A COMMONLY USED ANIM, I REALLY SHOULD FIX IT
		-- if animcheck:IsCurrentAnimation("chop_loop") == true then
			-- print("HOWS MY SWING LOOK", animcheck:GetCurrentAnimationTime() / GLOBAL.FRAMES)
			-- --SINCE CHOP_PST DOES NOT EXIST, WE NEED TO GUESTIMATE THE TIME IN THE ANIMATION WHERE IT WOULD NORMALY START
			-- if animcheck:GetCurrentAnimationTime() >= (15 * GLOBAL.FRAMES) then
				-- if (weaponmodel:GetAnimState():IsCurrentAnimation("eatquick") == false) then
					-- weaponmodel:GetAnimState():PlayAnimation("eatquick")
					-- weaponmodel:GetAnimState():SetTime(13 * GLOBAL.FRAMES)
					-- weaponmodel:GetAnimState():PushAnimation("idle")				
					-- override = false
				-- end
				
			-- else --ITS CHOP LOOP, BUT WE'RE STILL SWINGING THE AXE. DONT HIDE IT YET
				-- override = true
			-- end
			
			-- if animcheck:GetCurrentAnimationTime() <= (2 * GLOBAL.FRAMES) then
				-- inst:ShakeCamera(GLOBAL.CAMERASHAKE.SIDE, .1, .01, 0.1) --MIND IF WE GET A LIL CAM SHAKE?
			-- end
		-- end
		
		
		--IF HOLDING A PARTICAL EMMITTER AND STANDING STILL, AUTO FACE THE CAMERA SO THE PARTICALS MATCH OUR POSITION
		if animcheck:IsCurrentAnimation("idle_loop") == true and holdingflame == true then
			GLOBAL.GetPlayer().components.retmanager:FacePlayerToCamera()
		end
		
		
		--OUR PLAYER SHOULD FACE THE CAMERA NO MATTER WHAT
		if animcheck:IsCurrentAnimation("build_pre") or animcheck:IsCurrentAnimation("build_loop") then
			GLOBAL.GetPlayer().components.retmanager:FacePlayerToCamera()
		end
		
		
		for i, v in ipairs(modelanimoverrides) do
			if animcheck:IsCurrentAnimation(v) == true then
				override = true
				-- break
			end
		end
		
		--1-22- A SECOND CHECK FOR SOME COMMON ANIMATIONS TO TRIGGER THE WEAPONMODEL TWITCH
		for i, v in ipairs(weapontwitchoverrides) do
			if animcheck:IsCurrentAnimation(v) == true then 
				
				--IF THE PLAYER IS NOT HOLDING AN ITEM, SHOW THE ANIMATION INSTEAD. VISUAL FEEDBACK IS IMPORTANT FOR GAMEFEEL!!
				if GLOBAL.GetPlayer().components.inventory:GetEquippedItem(GLOBAL.EQUIPSLOTS.HANDS) == nil then
					-- GLOBAL.GetPlayer():ShakeCamera(GLOBAL.CAMERASHAKE.VERTICAL, .2, .005, 0.5) --mode, duration, speed, scale, source_or_pt, maxDist
					return true
				end
				
				if (weaponmodel:GetAnimState():IsCurrentAnimation("eatquick") == false) then
					--JUST PLAY THE ANIMATION. DON'T EVEN WORRY ABOUT THE OVERRIDE VALUE
					weaponmodel:GetAnimState():PlayAnimation("eatquick")
					weaponmodel:GetAnimState():PushAnimation("idle")
					
					--AND OF THOSE ANIMATIONS, SHOULD ANY OF THOSE SKIP TO MID-ANIMATION?
					for i, b in ipairs(weaponlifts) do
						if animcheck:IsCurrentAnimation(b) == true then
							override = false
							weaponmodel:GetAnimState():SetTime(10 * GLOBAL.FRAMES)
							-- break
						end
					end
					
				end
			end
		end
		
		return override
	end
	
	
	
	--1-19 IS IT... REALLY GONNA COME DOWN TO THIS?!  --AT LEAST IT WORKS :/
	inst:DoPeriodicTask(0, function(inst) --//SIGH/... EVERY FRAME, CHECK THE ANIMATION NAME TO SEE IF IT MATCHES THE LIST :/ THIS IS SUCH A BAD WAY TO DO IT
		if GLOBAL.GetPlayer().FPSmode == false then return end
		
		if inst:HasTag("show_fp_anim") then return end --4-12-18 FOR CUSTOM STUFF THAT COULD INVOLVE MODS FOR MODS. REUSEd
		
		local weaponmodel = inst.HUD.controls.playermodel
		
		-- if inst.AnimState:IsCurrentAnimation("chop_loop") then
		if CheckModelAnimOverrides(inst.AnimState) then --JUST SEND THE CLIENT'S ANIM STATE IN TO BE COMPARED WITH THE TABLE
			
			weaponmodel:Hide() --THIS IS WHAT WE NEEDED
			GLOBAL.GetPlayer().AnimState:SetMultColour(1,1,1,1)
			ReApplyGhostHands(inst) --RE-APPLY THE FLOATING HANDS
		else
			weaponmodel:Show()
			weaponmodel:MoveToBack()
			inst.HUD.controls.sidetext:MoveToBack()
			inst.HUD.controls.activeinvitem:MoveToBack()
			-- GLOBAL.GetPlayer():Hide() --WAIT... THIS MAKES YOU INVISIBLE TO THE WHOLE WORLD. ANIMALS CANT SEE YOU
			GLOBAL.GetPlayer().AnimState:SetMultColour(0,0,0,0) --I GUESS WE'LL HAVE TO DO THIS INSTEAD
		end
		
		--1-22- HAVE SOMETHING TO CHECK IF SELF SHOULD BE SELECTABLE (LIKE WHEN RIDING)
		if inst.components.rider and inst.components.rider:GetMount() ~= nil then
			inst.components.retmanager.selfselecable = true
		else
			inst.components.retmanager.selfselecable = false
		end
		
	end)
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	local reskintable = {}	--FOR ITEMS WHERE BUILD NAMES DO NOT MATCH THEIR PREFAB NAME
	-- local RESKINTABLE = {"hambat" = "ham_bat"}
	
	table.insert(reskintable, { prefabname = "hambat", buildname = "ham_bat" })
	table.insert(reskintable, { prefabname = "blowdart_sleep", buildname = "blowdart_pipe" })
	table.insert(reskintable, { prefabname = "blowdart_fire", buildname = "blowdart_pipe" })
	table.insert(reskintable, { prefabname = "blowdart_yellow", buildname = "blowdart_pipe" })
	table.insert(reskintable, { prefabname = "blowdart_poison", buildname = "blowdart_pipe" })
	table.insert(reskintable, { prefabname = "staff_tornado", buildname = "tornado_stick" })
	table.insert(reskintable, { prefabname = "staff_tornado", buildname = "tornado_stick" })
		table.insert(reskintable, { prefabname = "icestaff", buildname = "bluestaff" })
		table.insert(reskintable, { prefabname = "firestaff", buildname = "redstaff" })
		table.insert(reskintable, { prefabname = "telestaff", buildname = "puplestaff" })
		table.insert(reskintable, { prefabname = "orangestaff", buildname = "orangestaff" })
		table.insert(reskintable, { prefabname = "greenstaff", buildname = "greenstaff" })
		table.insert(reskintable, { prefabname = "yellowstaff", buildname = "yellowstaff" })
		table.insert(reskintable, { prefabname = "opalstaff", buildname = "opalstaff" })
		table.insert(reskintable, { prefabname = "volcanostaff", buildname = "volcanostaff" })
	table.insert(reskintable, { prefabname = "nightsword", buildname = "nightmaresword" })
	table.insert(reskintable, { prefabname = "waxwell_shadowstriker", buildname = "nightmaresword_shadow" })
	table.insert(reskintable, { prefabname = "tentaclespike", buildname = "spike" })
	table.insert(reskintable, { prefabname = "multitool_axe_pickaxe", buildname = "object" })
	table.insert(reskintable, { prefabname = "grass_umbrella", buildname = "parasol" })
	table.insert(reskintable, { prefabname = "lucy", buildname = "lucy_axe" })
	table.insert(reskintable, { prefabname = "bottlelantern", buildname = "bottlle_lantern" }) --VANILLA DS CHANGES- FOR SHIPWRECKED  --THEY SPELLED BOTTLE WRONG GOD DANGIT 
	table.insert(reskintable, { prefabname = "tarlamp", buildname = "swap_tarlamp" })
	table.insert(reskintable, { prefabname = "spear_launcher", buildname = "speargun" })
	table.insert(reskintable, { prefabname = "needlespear", buildname = "cactus_spike" })
	table.insert(reskintable, { prefabname = "peg_leg", buildname = "object" })
	
	
	
	local function CheckPrefabList(prefab)
		local reskin = prefab
		
		for i, v in ipairs(reskintable) do
			if prefab == v.prefabname then
				reskin = v.buildname
			end
		end
	
		return reskin
	end
	
	
	--AND ONE FOR THE PLAYERMODEL.
	local myactiveitem = nil
	
	print("PLAYER INIT J")
	
	local function UpdateWeaponModel()
		--STARTUP CAN SOMETIMES BUGGER THIS UP WHEN LOADING A SAVE FILE BEFORE HUD IS READY
		if not inst.HUD or not inst.HUD.controls or not inst.components.inventory or inst.FPSmode == false then return end --BUT THEN WONT THE ACTIVE ITEM BE INVISIBLE ON STARTUP?... EH, OH WELL.
		
		--THE ITEM WE JUST EQUIPPED MAY HAVE JUST UNHIDDEN SOME OF OUR CLOTHES. REHIDE EVERYTHING
		ReApplyGhostHands(inst, true) --SET TRUE TO FORCE REBUILD THE WHOLE PLAYER MODEL
		local tool = inst.components.inventory:GetEquippedItem(GLOBAL.EQUIPSLOTS.HANDS)
		
		

		if not tool then
			myactiveitem = nil
			inst.HUD.controls.playermodel:GetAnimState():Hide("ARM_carry")
			
		elseif tool.prefab ~= myactiveitem then
			-- local skin_build = tool or nil --VANILLA DS CHANGE - GET RID OF THE SKIN CHECKER
			-- local skin_build = tool and tool.entity.skin_build_name or nil
			local weaponmodel = inst.HUD.controls.playermodel
			
			weaponmodel:GetAnimState():Show("ARM_carry")
			
			--TO LET OUR MODEL KNOW IF OUR ITEM EMITS A PARTICAL SO IT CAN TURN TO MATCH OUR CAMERA
			if tool:HasTag("lighter") or tool:HasTag("light") then
				holdingflame = true
			else
				holdingflame = false
			end
			
			if tool then
				-- weaponmodel:GetAnimState():OverrideSymbol("swap_object", "swap_axe", "swap_axe")
				local swapfile = "swap_"..tostring(CheckPrefabList(tool.prefab)) --FIRST MAKE SURE WE HAVE THE RIGHT BUILD NAME
				local swapfile2 = swapfile --IS GENERALLY THE SAME THING, EXCEPT FOR A FEW CASES, WHICH WILL SET BELOW
				
						--LONG LIST OF TOOLS WITH SWAP MODELS THAT DONT MATCH THEIR BUILD NAME--
				--SINCE STAFFS ARE ALL OVER THE PLACE
				if tool.prefab == "firestaff" or tool.prefab == "icestaff" or tool.prefab == "telestaff" or tool.prefab == "orangestaff" or
				tool.prefab == "greenstaff" or tool.prefab == "yellowstaff" or tool.prefab == "opalstaff" or tool.prefab == "volcanostaff" then 
					swapfile = tostring(CheckPrefabList(tool.prefab)) --VANILLA DS CHANGE --IN THIS VERSION, STAFF BUILDS DONT HAVE "SWAP_" IN FRONT OF THEM, I GUESS... AN IMPORTANT HIGH PRIORITY CHANGE
					swapfile2 = "swap_staffs" 
				end
				--AND THEN THAT WEIRD MULTITOOL
				if tool.prefab == "multitool_axe_pickaxe" then swapfile2 = "swap_multitool_axe_pickaxe" end
				--AND NOW SPEARS TOO
				if tool.prefab == "spear_poison" or tool.prefab == "spear_obsidian" then 
					swapfile2 = "swap_"..tostring(tool.prefab) --VANILLA DS CHANGE --IN THIS VERSION, STAFF BUILDS DONT HAVE "SWAP_" IN FRONT OF THEM, I GUESS... AN IMPORTANT HIGH PRIORITY CHANGE
					swapfile = "swap_spear" 
				end
				if tool.prefab == "peg_leg" then --SHIPWRECKED
					swapfile2 = "swap_peg_leg"
				end
				if tool.prefab == "obsidianaxe" then
					swapfile2 = "swap_axe_obsidian"
					swapfile = "swap_axe"
				end
				if tool.prefab == "obsidianmachete" then
					swapfile2 = "swap_machete_obsidian"
					swapfile = "swap_machete"
				end
				--VANILLA DS CHANGES --ALRIGHT. WHY NOT HAVE A LITTLE FUN WITH IT??
				if tool.prefab == "lantern" then 
					if tool.components.fueled:IsEmpty() then
						inst.HUD.controls.playermodel:GetAnimState():Hide("LANTERN_OVERLAY")
						swapfile = "swap_lantern_off"
					else
						inst.HUD.controls.playermodel:GetAnimState():Show("LANTERN_OVERLAY")
						swapfile = "swap_lantern_on"
					end
				else
					-- inst.HUD.controls.playermodel:GetAnimState():Hide("LANTERN_OVERLAY")
				end 
				--VANILLA DS CHANGES
				if tool.prefab == "bottlelantern" then
					swapfile = "swap_lantern_off"
				end
				if tool.prefab == "tarlamp" then
					swapfile = "swap_lantern_off" --ONLY THE TURNED-OFF VERSIONS SHOW UP ON THE HUD...
					swapfile2 = "swap_tarlamp"
				end
				if tool.prefab == "spear_launcher" then
					swapfile2 = tool.override_bank --APPARENTLY THIS THING KEEPS ITS OWN STORED
				end
				if tool.prefab == "harpoon" then
					local swapfile = "swap_object"
					local swapfile2 = "swap_harpoon"
				end
				
				weaponmodel:GetAnimState():OverrideSymbol("swap_object", swapfile2, swapfile)
				
				--OKAY, LETS HANDLE SKIN BUILDS DOWN HERE, AFTER WE'VE DONE ALL THIS BUILD NAME SORTING--
				-- if skin_build ~= nil then
					-- print("SKINNED BUILD DETECTED!!", skin_build)
					-- weaponmodel:GetAnimState():OverrideItemSkinSymbol("swap_object", skin_build, swapfile2, tool.GUID, swapfile) --OKAY COOL, NOW HOW DO I TEST IT?... I AM BUT A MERE SKINLESS PEASANT
				-- end
				
				--2-3-18 OKAY, SO, IF ITS A TALKING AXE, RAISE THE SPEECH HIGHT A LITTLE CUZ WE CANT SEE IT
				if tool.components.talker then 
					tool.components.talker.offset = GLOBAL.Vector3(0, -100, 0) --THAT HIGH ENOUGH?
				end
				
				print("GOD YOURE SUCH A ", tool, swapfile2, swapfile)
			else
				weaponmodel:GetAnimState():Hide("ARM_carry") 
				
			end
			
			-- weaponmodel:GetAnimState():PlayAnimation("item_out") --THIS SHOULD BE IT! WHY ISNT IT WORKING?...
			weaponmodel:GetAnimState():PlayAnimation("eatquick") --SO... TURNS OUT THIS VERSION DOESN'T HAVE ALL THE SAME ANIMATIONS. LAME.
			weaponmodel:GetAnimState():PushAnimation("idle")
			myactiveitem = tool.prefab
			ReApplyGhostHands(inst, true)
		end
	
	end
	
	
	
	inst:ListenForEvent("equip", UpdateWeaponModel)
	inst:ListenForEvent("updateweaponmodeldirty", UpdateWeaponModel) --FOR OUR OWN DEVICE...
	
	inst:ListenForEvent("unequip", function()
		myactiveitem = nil
		-- ReApplyGhostHands(inst, true) --DONT FORGET THIS YOU DUMMY! OR ELSE I GUESS THE WHOLE THING RE-SHOWS ITSELF
		UpdateWeaponModel() --CANT I JUST DO THIS??
	end)
	
	
	
	--AND THEN KICKSTART IT ONCE IN CASE THEY ARE ALREADY HOLDING SOMETHING
	inst:DoTaskInTime(0.1, function() --DS VANILLA CHANGE - DONT GIVE EM TIME TO WAIT IN THIS VERSION!!
		UpdateWeaponModel()
		inst.components.retmanager:UpdateSkybox()
		
		if GetModConfigData("STARTINGVIEW") == "default" then
			ToggleCamView() --IF THEY WANNA START OUT IN NORMAL VIEW, TOGGLE THEM A SECOND AFTER LOADING IN
		else
			
			if inst.components.transparentobstacles then
				inst.components.transparentobstacles.is_in_fps = true
			end
			
			--DS VANILLA CHANGE
			if inst.AnimState:IsCurrentAnimation("sleep") then
				GLOBAL.TheCamera:SetFPSMode()
				GLOBAL.TheCamera:Snap()
				GLOBAL.TheCamera.headingtarget = 300--270 --IN CASE ITS A NEW GAME, SO WE WOULD TURN TO FACE MAXWELL
				GLOBAL.TheCamera.pitch = 65 --START OFF LOOKING AT THE FLOOR
				GLOBAL.TheCamera:Snap()
				GLOBAL.TheCamera:EnableTempGains()
				GLOBAL.TheCamera.pitch = -30  -- -65 --AND SLOWLY LOOK UP AT HIS TALLNES
				inst.recentermouse = true
			end
		
		end
		
		if GetModConfigData("HUDHINTS") then --REUSED
			GLOBAL.GetPlayer().HUD.controls.sidetext:Hide()
		end
	end)
	
	
	
	
	--SET SPOTLIGHT ON ANY LARGE OBJECTS THE PLAYER BUMPS UP AGAINST
	inst.Physics:SetCollisionCallback(function(inst, object)
		-- if not (object and object:IsValid()) then return end --WE ALREADY DESTROYED IT! GET OUTTA HERE
		if not ((object and object:IsValid() and object.Transform) and (inst and inst:IsValid())) then return end
		
		-- if math.abs(angle - myangle) <= 65 then --IF THE PLAYER IS LOOKING IN THE GENERAL DIRECTION OF IT'S CENTER MASS
			-- local facepos_x, facepos_y, facepos_z = object.Transform:GetWorldPosition()
			-- local facepos_x, facepos_y, facepos_z = object.Transform:GetWorldPosition()
			-- local dist = math.sqrt(inst:GetDistanceSqToPoint(facepos_x, facepos_y, facepos_z))
			--VANILLA DS CHANGE --OKAY... I GUESS LETS TRY SOMETHING DIFFERENT. I GUESS FACEPOS DOESN'T WORK THE SAME WAY IN THIS GAME
			local p0 = GLOBAL.Vector3(inst.Transform:GetWorldPosition())
			local p1 = GLOBAL.Vector3(object.Transform:GetWorldPosition())
			local dist = math.sqrt(GLOBAL.distsq(p0, p1))
			inst.components.retmanager.spotlightent = object
			inst.components.retmanager.spotlightdist = dist
		-- end
	end)
	
	
	-- print("FLOOR RET FULLY INITIALIZED")
	
	
	--VANILLA DS CHANGE - NOW THAT WE CANT USE WORLD POST INIT- WE JUST PASTE IT IN HERE INSTEAD
	-- local player = GLOBAL.GetPlayer()
	
	-- if not GetModConfigData("STARTINGVIEW") == "default" then
		-- ReApplyGhostHands(player) --APPLY THE FLOATING HANDS SKIN
		-- player:DoTaskInTime(0.5, function()
			-- GLOBAL.TheCamera:SetFPSMode()
			-- player.recentermouse = true
			-- if player.components.transparentobstacles then
				-- player.components.transparentobstacles.is_in_fps = true
			-- end
		-- end)
	
	-- end
end

-- AddSimPostInit( FloorReticule )
AddPlayerPostInit(FloorReticule) --DS CHANGE VANILLA
-- AddClassPostConstruct("widgets/controls", FloorReticule) --THIS IS A WEIRD WAY TO DO IT...


--CLIENTSIDE SKINS ARE TOO WEIRD
-- local function UpdateAnimOverrideSanity(parent)
    -- parent.AnimState:SetClientSideBuildOverrideFlag("insane", parent.components.sanity:GetPercentNetworked() <= (parent:HasTag("dappereffects") and TUNING.DAPPER_BEARDLING_SANITY or TUNING.BEARDLING_SANITY))
-- end



--ALRIGHT SIMPLEX, LETS TRY YOUR VERSION...
-- AddPrefabPostInit("world", function(wrld)
	-- wrld:ListenForEvent("playeractivated", function(wrld, player)
		-- if player == GLOBAL.GetPlayer() then
			
			
	
			-- -- GLOBAL.TheCamera:SetNewDefault()
			-- -- inst:DoTaskInTime(1, function()
				-- -- GLOBAL.TheCamera:SetFPSMode()
			-- -- end)
			
			
			-- if GetModConfigData("STARTINGVIEW") == "default" then
				-- ToggleCamView() --IF THEY WANNA START OUT IN NORMAL VIEW, TOGGLE THEM A SECOND AFTER LOADING IN
			-- else
				-- ReApplyGhostHands(player) --APPLY THE FLOATING HANDS SKIN
				-- player:DoTaskInTime(0.5, function()
					-- GLOBAL.TheCamera:SetFPSMode()
					-- player.recentermouse = true
					-- if player.components.transparentobstacles then
						-- player.components.transparentobstacles.is_in_fps = true
					-- end
				-- end)
			
			-- end
		-- end
	-- end)
-- end)





--ALL THIS JUST TO DISABLE DRAGWALKING  --I SHOULD PROBABLY FIND A BETTER WAY TO DO THIS

AddComponentPostInit("playercontroller", function(self)

	--OH BOY WE NEED A LOT OF GLOBALS FOR THIS ONE
	local TheInput = GLOBAL.TheInput
	-- local TheFocalPoint = GLOBAL.TheFocalPoint --DOESNT EXIST IN VANILLA
	
	local CONTROL_PRIMARY = GLOBAL.CONTROL_PRIMARY
	local ACTIONS = GLOBAL.ACTIONS
	local BufferedAction = GLOBAL.BufferedAction
	
	
	--THE SINGLEPLAYER VERSION
	function self:OnLeftClick(down)
    
		if not self:UsingMouse() then return end
		
		if not down then return self:OnLeftUp() end

		self.startdragtime = nil

		if not self:IsEnabled() then return end
		
		if TheInput:GetHUDEntityUnderMouse() then 
			self:CancelPlacement()
			-- print("FPS MODE - INCORRECTLY CANCELED PLACEMENT", TheInput:GetHUDEntityUnderMouse())
			return 
		end

		if self.placer_recipe and self.placer then
			--do the placement
			if self.placer.components.placer.can_build then
				local pos = self.placer.components.placer.targetPos or TheInput:GetWorldPosition()
				self.inst.components.builder:MakeRecipe(self.placer_recipe, TheInput:GetWorldPosition())
				
				self:CancelPlacement()
			end
			return
		end
		
		if self.inst.FPSmode == false then --ONLY DO THIS IF NOT IN FIRST PERSON. 
			self.inst.components.combat.target = nil --REMOVING THIS FOR FIRST PERSON SEEMS LIKE IT COULD BE A BAD IDEA...
		end
		
		if self.inst.inbed then
			self.inst.inbed.components.bed:StopSleeping()
			return
		end
		
		local action = self:GetLeftMouseAction()
		if action then
			self:DoAction( action )
		else
			
			if self.inst.FPSmode == false then --VANILLA DS CHANGE -- THIS BE HOW IT WORKS NOW
				self:DoAction( BufferedAction(self.inst, nil, ACTIONS.WALKTO, nil, TheInput:GetWorldPosition()) ) 		
				local clicked = TheInput:GetWorldEntityUnderMouse()
				if not clicked then
					self.startdragtime = GLOBAL.GetTime()
				end
			end
		end
		
	end
end)


--4-24 NEED THIS AGAIN
AddComponentPostInit("playercontroller", function(self) 
	function self:GetCursorInventoryObject()
		-- if self.inst.HUD ~= nil and TheInput:ControllerAttached() then
		-- print("GetCursorInventoryObject")
		if self.inst.HUD ~= nil and (GLOBAL.TheInput:ControllerAttached() or GLOBAL.GetPlayer().FPSmode == true) then
			local item = self.inst.HUD.controls.inv:GetCursorItem()
			return item ~= nil and item:IsValid() and item or nil
		end
	end
	
	
	--SPECIAL HANDLER THAT PREVENTS WALKING FORWARD FROM OVERWRITING A BUFFERED ACTION IF LOOKING AT IT
	-- function self:GetRemoteDirectVector()
		-- -- print("REMOTE WALKIN HERE")
		-- if self.inst:GetBufferedAction() ~= nil then return end
		
		-- return self.remote_vector.y == 1 and self.remote_vector or nil
	-- end
end)





modimport 'scripts/input_changes.lua'


modimport 'scripts/inv_bar_changes.lua'






--INV ACTION KEY_E
GLOBAL.TheInput:AddKeyDownHandler(GetModConfigData("ACTIONKEY"), function(down) 
	if down and GLOBAL.IsPaused() or (not GLOBAL.GetPlayer()) or GLOBAL.GetPlayer().FPSmode == false then return end
	-- if GLOBAL.GetPlayer().HUD and (GLOBAL.GetPlayer().HUD:IsChatInputScreenOpen() or GLOBAL.GetPlayer().HUD:IsConsoleScreenOpen()) then return end
	if not GLOBAL.GetPlayer().HUD or (GLOBAL.GetPlayer().HUD:HasInputFocus()) then return end --MUCH BETTER
	
	
	
	local player = GLOBAL.GetPlayer()
	local inv_obj = player.components.playercontroller:GetCursorInventoryObject()
	if inv_obj ~= nil then
		-- player.components.playercontroller:DoControllerUseItemOnSelfFromInvTile(inv_obj)
		
		local item = player.components.inventory:GetItemInSlot(player.HUD.controls.inv:GetCursorSlot())
		-- player.components.inventory:UseItemFromInvTile(item) --WAIT A MINUTE....
		player.components.inventory:UseItemFromInvTile(inv_obj) --OH! IM DUMB. I DIDNT EVEN NEED ITEM
		
		-- print("WHAT SLOT NUMBER IS THIS?", player.HUD.controls.inv:GetCursorSlot(), item, inv_obj)
	end
	
	--GLOBAL.GetPlayer().HUD.controls.inv
	-- player.components.inventory:SelectActiveItemFromSlot(player.HUD.controls.inv:GetCursorSlot())
	-- player.components.inventory:SwapActiveItemWithSlot(player.HUD.controls.inv:GetCursorSlot())
	
	-- player.components.inventory:TakeActiveItemFromAllOfSlot(player.HUD.controls.inv:GetCursorSlot())
	
	-- AddAllOfActiveItemToSlot
	
	
	--IN CASE PLAYERS GET CONFUSED, ALSO LET (E) SWAP AND DROP INTO INV SPACES IF AN ACTIVE ITEM IS HELD
	-- local highlightedslot = player.HUD.controls.inv:GetCursorSlot()
	-- player.components.inventory:SwapActiveItemWithSlot(highlightedslot)
	-- player.components.inventory:PutAllOfActiveItemInSlot(highlightedslot)
	
	--THIS CODE MIGHT STILL COME IN HANDY LATER ON. I MIGHT LEAVE IT HERE FOR A BIT --HAH! IT SURE DID COME IN HANDY
	-- if player.HUD.controls.inv:GetCursorSlot() == nil then --THEN ITS PROBABLY AN ITEM SLOT
		-- -- local item = player.components.inventory:GetEquippedItem(item.components.equippable:EquipSlot(inv_obj))
		-- -- player.components.inventory:EquipActiveItem()
		-- player.HUD.controls.inv:OnFPSControl() --THIS ONES BETTER - ALTHOUGH THIS IS A SHADY WAY TO RUN IT... AM I SURE THIS IS SAFE??? -NOT REALLY
		-- return --BUT IF IT RAN, WE ALL GOOD. ASSUME OUR WORK HERE IS DONE (RIGHT?)
	-- end
	
	--2-17-18 EYYY, LOOK AT THAT. THE SOLVE-ALL ANSWER TO EVERYTHING
	if player.components.inventory:GetActiveItem() ~= nil then
		player.HUD.controls.inv:OnFPSControl()
	end
end)


--INV INSPECT KEY_R
GLOBAL.TheInput:AddKeyDownHandler(GetModConfigData("INSPECTKEY"), function(down) 
	if down and GLOBAL.IsPaused() or (not GLOBAL.GetPlayer()) or GLOBAL.GetPlayer().FPSmode == false then return end
	if not GLOBAL.GetPlayer().HUD or (GLOBAL.GetPlayer().HUD:HasInputFocus()) then return end
	

	--JUST CLICK THE DANG SLOT!! 3-5-18  
	GLOBAL.GetPlayer().HUD.controls.inv.active_slot:Click() --ARE YOU FOR REAL, IT WAS THIS EASY THE WHOLE TIME????
	--THE ENTIRE THING IN JUST 1 LINE OF CODE... SMH
	
	
	--WELP, GUESS THIS WHOLE THING IS POINTLESS NOW
	--[[
	local player = GLOBAL.GetPlayer()
	local inv_obj = player.components.playercontroller:GetCursorInventoryObject()
	local highlightedslot = player.HUD.controls.inv:GetCursorSlot()
	print("THE ACTIVE SLOT IS", highlightedslot)
	
	
	--OKAY, WE NEED A WAY TO GET EQUIP SLOT ITEMS
	local hand_item = player.components.inventory:GetActiveItem() or inv_obj
	-- local active_item = player.components.inventory:GetActiveItem()
	-- if active_item ~= nil and active_item.components.equippable ~= nil and active_item.components.equippable:EquipSlot() == self.active_slot.equipslot then
		if hand_item and hand_item.components.equippable and hand_item.components.equippable:EquipSlot() then
			--WAIT, WE WANT THE R KEY TO SWAP INV OBJECTS, NOT USE THEM!! ONLY DO THIS ON EQUIP SLOTS
			if highlightedslot == nil then
				player.HUD.controls.inv:OnFPSControl() --OUR OWN BETTER WAY!
				return --OUR WORK HERE IS DONE (ALSO IT WOULD CRASH IF WE CONTINUED ANYWAYS)
			end
		
	end
	
	
	
	if inv_obj ~= nil then
		-- player.components.playercontroller:DoControllerInspectItemFromInvTile(inv_obj) --USED TO BE FOR INSPECTING ONLY
		
		--WE HAVE TO DO THINGS IN A SPECIFIC ORDER.
		--IF AN OBJECT EXISTS THERE, SWAP IT WITH THAT ONE.
		player.components.inventory:SwapActiveItemWithSlot(highlightedslot)
		--ELSE, PICKS UP SELECTED ITEM
		player.components.inventory:TakeActiveItemFromAllOfSlot(highlightedslot)
		
	else --DROP IT IN THE SLOT
		player.components.inventory:PutAllOfActiveItemInSlot(highlightedslot)

	end
	--print("OBJECK CHECK", inv_obj, highlightedslot)
	]]
	
end)




--MAKE THE CAMERA WAIT UNTIL THE PLAYER LETS GO OF Q AFTER TOGGELING CAMS TO AVOID GOING NUTS AND DISORIENTING THE PLAYER
GLOBAL.TheInput:AddKeyDownHandler(GLOBAL.MODUNLOCKKEY, function() 
	if GLOBAL.IsPaused() or (not GLOBAL.GetPlayer()) then return end
	--IF PLAYER IS HOLDING CTRL, JUST SWAP CAMERA MODES INSTEAD. REUSEd
	if GLOBAL.TheInput:IsKeyDown(GLOBAL.KEY_CTRL) then
		ToggleCamView()
	end
	if GLOBAL.GetPlayer().HUD and GLOBAL.GetPlayer().FPSmode == true then  --4-20-18 --DANK MEMES LOL.  --IM SORRY PLEASE FORGIVE ME
		GLOBAL.GetPlayer().HUD.controls.sidetext:Hide() 
		GLOBAL.GetPlayer().HUD.controls:ShowStatusNumbers() --REUSEd -- TO SHOW/HIDE THE HUD NUMBERS
	end
end)

--REUSEd -- 4-17-18 TO SHOW/HIDE THE HUD NUMBERS
GLOBAL.TheInput:AddKeyUpHandler(GLOBAL.MODUNLOCKKEY, function() 
	if GLOBAL.IsPaused() or (not GLOBAL.GetPlayer()) then return end
	GLOBAL.TheCamera.holdq = false
	if GLOBAL.GetPlayer().HUD and GLOBAL.GetPlayer().FPSmode == true then 
		GLOBAL.GetPlayer().HUD.controls:HideStatusNumbers()
	end
end)






local pausewheel = false
--INV SCROLL UP
-- GLOBAL.TheInput:AddControlHandler(GLOBAL.CONTROL_MAP_ZOOM_IN, function() --GESTURE_ZOOM_IN --CONTROL_SCROLLFWD --MOUSEBUTTON_SCROLLUP
GLOBAL.TheInput:AddControlHandler(GLOBAL.CONTROL_MAP_ZOOM_IN, function(down)
	-- print("UPWEGO")
	if GLOBAL.IsPaused() or (not GLOBAL.GetPlayer()) or GLOBAL.GetPlayer().FPSmode == false or not GLOBAL.TheInput:ShouldMouseLock() then return end
	
	-- if pausewheel == true then --NOW THIS IS REQUIRED TO FORCE IT TO IGNORE EVERY OTHER INPUT, SINCE SCROLLING ONCE RUNS TWICE
		-- pausewheel = false
	-- else
		-- GLOBAL.GetPlayer().HUD.controls.inv:CursorLeft() --SCROLL INV  --WHY DOES IT RUN TWICE????
		-- pausewheel = true --//SIGH/
	-- end
	
	--2-12-18 TAKE TWO!
	if down then --WELL, THATS A LITTLE BETTER I GUESS. ALRIGHT!! REDO ALL THE BUTTONHANDLERS WITH THIS NEW VERSION
		-- GLOBAL.GetPlayer().HUD.controls.inv:CursorLeft()
		GLOBAL.GetPlayer().HUD.controls.inv:CursorFPSScrollup()
	end
	
	-- print("THE LIGHT?", GLOBAL.TheWorld.components.ambientlighting._realcolour.currentcolour)
	-- LightWatcher
	
end)


GLOBAL.TheInput:AddControlHandler(GLOBAL.CONTROL_MAP_ZOOM_OUT, function(down)
	if GLOBAL.IsPaused() or (not GLOBAL.GetPlayer()) or GLOBAL.GetPlayer().FPSmode == false or not GLOBAL.TheInput:ShouldMouseLock() then return end
	
	if down then
		-- GLOBAL.GetPlayer().HUD.controls.inv:CursorRight() --SCROLL INV
		
		--2-19-18 OH WE'RE NOT DONE YET!! TIME FOR BACKPACK INTEGRATION!!! WE GOTTA GET UP AND DOWN SOMEHOW, DONT WE?
		--LETS TRY THE SAME VERSION BUT WITH "SAMECONTAINER" SET TO FALSE
		-- GLOBAL.GetPlayer().HUD.controls.inv:CursorNav(GLOBAL.Vector3(1,0,0))
		GLOBAL.GetPlayer().HUD.controls.inv:CursorFPSScrolldown()
		
	end
end)



--AND FOR THE CONTROLLER VERSION
GLOBAL.TheInput:AddControlHandler(GLOBAL.CONTROL_ROTATE_LEFT, function(down)
	if not GLOBAL.TheInput:ControllerAttached() or GLOBAL.IsPaused() or (not GLOBAL.GetPlayer()) or GLOBAL.GetPlayer().FPSmode == false then return end

	--SERIOUSLY?? EVEN THE CONTROLLER VERSION NEEDS IT???
	-- if pausewheel == true then --NOW THIS IS REQUIRED TO FORCE IT TO IGNORE EVERY OTHER INPUT, SINCE SCROLLING ONCE RUNS TWICE
		-- pausewheel = false
	-- else
		-- GLOBAL.GetPlayer().HUD.controls.inv:CursorLeft() --SCROLL INV
		-- pausewheel = true --//SIGH/
	-- end
	
	if down then
		GLOBAL.GetPlayer().HUD.controls.inv:CursorLeft() --SCROLL INV
	end
end)

GLOBAL.TheInput:AddControlHandler(GLOBAL.CONTROL_ROTATE_RIGHT, function(down)
	if not GLOBAL.TheInput:ControllerAttached() or GLOBAL.IsPaused() or (not GLOBAL.GetPlayer()) or GLOBAL.GetPlayer().FPSmode == false then return end
	if down then
		GLOBAL.GetPlayer().HUD.controls.inv:CursorRight() --SCROLL INV
	end
end)



--WE NEED ONE TO RE-ENABLE CONTROLLER CRAFTING GOG DANG
GLOBAL.TheInput:AddControlHandler(GLOBAL.CONTROL_OPEN_CRAFTING, function()
	if GLOBAL.IsPaused() or (not GLOBAL.GetPlayer()) or GLOBAL.GetPlayer().FPSmode == false then return end
	if GLOBAL.GetPlayer().HUD ~= nil then
		GLOBAL.GetPlayer().HUD.controls.crafttabs:Show()
	end
end)




--TheInput:IsControlPressed(CONTROL_FORCE_ATTACK)
-- STRINGS.UI.CONTROLSSCREEN.INPUTS[1][MODACTIONKEY]
-- GLOBAL.TheInput:AddKeyDownHandler(GetModConfigData("INSPECTKEY"), function() 

--LOCK ONTO THE NEAREST ATTACK TARGET
GLOBAL.TheInput:AddControlHandler(GLOBAL.CONTROL_ATTACK, function()
	if GLOBAL.IsPaused() or (not GLOBAL.GetPlayer()) or GLOBAL.GetPlayer().FPSmode == false then return end
	if not GLOBAL.GetPlayer().HUD or (GLOBAL.GetPlayer().HUD:HasInputFocus()) then return end
	if GetModConfigData("AUTOTARGETLOCK") == false then return end --DONT BOTHER ANY OF THIS IF THE USER HAS THIS SETTING DISABLED
	
	-- print("----ATTACK SEQUENCE ACTIVATED----")
	-- GLOBAL.GetPlayer().components.retmanager:LockOnTarget()
	
	--OR... COULDN'T I JUST DO THIS?...
	--THIS WAS SO MUCH SIMPLER, I CAN'T BELEIVE I DID ALL THAT EXTRA WORK FOR NOTHING
	-- GLOBAL.GetPlayer().components.retmanager:LockOnPlayerAngle()   --OKAY. YOU GOTTA CHILL. THIS ONE GOES WONKY
	GLOBAL.GetPlayer():DoTaskInTime(0, function() GLOBAL.GetPlayer().components.retmanager:LockOnPlayerAngle() end) --AND AGAIN, JUST IN CASE THE FIRST ONE WAS TOO EARLY AND WE WEREN'T FACING OPPONENT
end)




--

local function FPSfollowtext(class)

	local w,h = GLOBAL.TheSim:GetScreenSize()

	function class:OnUpdate(dt)
		if class.target ~= nil and class.target:IsValid() then
			if not class.hashud then
				--legacy support for MODs
				class.text:SetScale(GLOBAL.TheFrontEnd:GetHUDScale())
			end
			local x, y
			if class.target.AnimState ~= nil then
				x, y = GLOBAL.TheSim:GetScreenPos(class.target.AnimState:GetSymbolPosition(class.symbol or "", class.offset.x, class.offset.y, class.offset.z))
			else
				x, y = GLOBAL.TheSim:GetScreenPos(class.target.Transform:GetWorldPosition())
			end
			-- print(y)
			
			--I JUST ADDED THIS DIFFERENT POS FOR THE PLAYER
			if class.target == GLOBAL.GetPlayer() and GLOBAL.GetPlayer().FPSmode then 
				-- class:SetPosition(x + class.screen_offset.x, 150, 0) --FPS CHANGE
				--ACTUALLY, IT WOULD BE BETTER TO HAVE IT APPEAR AT THE TOP, WHERE IT IS BLOCKING LESS OF THE SCREEN
				class.text:SetScale(GLOBAL.TheFrontEnd:GetHUDScale() * 1.5)
				class:SetPosition(x + class.screen_offset.x, h - 100, 0) --FPS CHANGE
			
			--ALSO ADDING THIS
			elseif GLOBAL.GetPlayer().FPSmode and not GLOBAL.GetPlayer().components.retmanager:IsPlayerLookingAt(GLOBAL.GetPlayer(), class.target, 145) then --IF BEHIND THE PLAYER, DON'T SHOW IT
				--WAIT... THIS IS ALL CLIENTSIDE RIGHT? I HOPE THIS DOESN'T MESS WITH CLIENTS VIEW 
				-- AWWW YEA B) NICE
				class:SetPosition(-50, -50, 0) --JUST HIDE IT BELOW OUR SCREEN LOL
			else
				class:SetPosition(x + class.screen_offset.x, y + class.screen_offset.y, 0)
			end
			-- class:SetPosition(x + class.screen_offset.x, y + class.screen_offset.y, 0)
			
		end
	end
end


AddClassPostConstruct("widgets/followtext", FPSfollowtext)







AddPrefabPostInit("boomerang", function(inst)
	
	local function OnThrown(inst, owner, target)
		if target ~= owner then
			owner.SoundEmitter:PlaySound("dontstarve/wilson/boomerang_throw")
		end
		inst.AnimState:PlayAnimation("spin_loop", true)
		
		--AND THIS IS WHAT IM ADDING IN
		inst.entity:AddDynamicShadow()
		inst.DynamicShadow:SetSize(0.7, 0.5) --GIVE IT A SHADOW SO ITS EASIER TO TELL WHEN TO CATCH
		inst.DynamicShadow:Enable(true)
		-- inst.Transform:SetScale(1,0.4,1) --STRETCH IT A LITTLE SO IT LOOKS PARRALEL WITH THE Z AXIS   --OR DONT, I GUESS
	end
	
	-- if GLOBAL.TheWorld.ismastersim then
		-- -- inst.components.projectile:SetOnThrownFn(OnThrown)
	-- end
	
	
	--CAN WE JUST... GIVE IT ONE NOW?...
	inst.entity:AddDynamicShadow()
	inst.DynamicShadow:SetSize(0.7, 0.5) --GIVE IT A SHADOW SO ITS EASIER TO TELL WHEN TO CATCH
	inst.DynamicShadow:Enable(true)

end)



--VANILLA DS CHANGE --IT'S A DIFFERENT PREFAB IN THIS VERSION

AddPrefabPostInit("cavelight", function(inst) --cave_exit
	
	inst:AddTag("sinkhole") --THERE WE GO! NOW ITS ALL IN LINE WITH THE DST VERSION. I THINK

end)


-- if GLOBAL:IsDLCInstalled(CAPY_DLC) then --IS IT REALLY CALLED CAPPY DLC?? LOL
	-- AddPrefabPostInit("lobster", function(inst)
		-- inst.default_alpha = 0.3 --LETS JUST SET THIS UP AHEAD OF TIME. THE WAY THEY SPAWN BELOW THE 0 Y AXIS MAKES THEM TOO VISIBLE FROM AFAR
	-- end)
	
	-- -- AddPrefabPostInit("lobster", function(inst)
		-- -- if player.components.transparentobstacles then --ONLY APPLY THIS IF SHADING IS ENABLED. OTHERWISE THEY WILL NEVER TURN BACK ON
			-- -- player.components.transparentobstacles.is_in_fps = false
			-- -- player.components.transparentobstacles.darkglow.AnimState:SetMultColour(0,0,0,0)
			-- -- player.components.transparentobstacles.darkfloor.AnimState:SetMultColour(0,0,0,0)
		-- -- end
		
		-- -- inst.default_alpha = 0.3 --LETS JUST SET THIS UP AHEAD OF TIME. THE WAY THEY SPAWN BELOW THE 0 Y AXIS MAKES THEM TOO VISIBLE FROM AFAR
	-- -- end)
-- end





--VANILLA DS CHANGE - SHIPWRECKED - SHUT THIS BALL UP ALREADY
AddComponentPostInit("sentientball", function(self) 

	function self:OnUpdate() --dt
		self.time_to_convo = self.time_to_convo - 5  --dt --IN THE ACTUALY COMPONENT, DT IS LITERALLY JUST SET TO 5. OK THEN.
		if self.time_to_convo <= 0 then
		
			--CHECK TO SEE IF WE'RE EVEN WITHIN A REASONABLE DISTANCE
			local p0 = GLOBAL.Vector3(GLOBAL.GetPlayer().Transform:GetWorldPosition())
			local p1 = GLOBAL.Vector3(self.inst.Transform:GetWorldPosition())
			local dist = math.sqrt(GLOBAL.distsq(p0, p1))
			if dist > 10 then
				--THEN DONT SAY ANYTHING! JUST RESET THE TALK TIMER
				self.last_say_time = GLOBAL.GetTime()
			else
				self:MakeConversation() --OKAY, NOW YOU CAN SAY SOMETHING
			end
		end
	end
end)



--HAMLET CHANGE --GIVE THIS THING SOME VISIBLE WALLS

AddPrefabPostInit("generic_wall_back", function(inst) --cave_exit
	
	inst:AddTag("wall_back") --THERE WE GO! NOW ITS ALL IN LINE WITH THE DST VERSION. I THINK

end)




