require "prefabutil"
	
local function setUp(inst,width,rotation,coords)
	if width then
		inst.wall_width = 0.5 --width --FPS HAMLET CHANGE - REMOVE BACK WALLS, THEYRE TOO BUGGY AND NOT WORTH
		MakeInteriorPhysics(inst, 0.5) --width
	end
	if rotation then
		inst.wall_rotation = rotation
		inst.Transform:SetRotation(rotation)
	end
end

local function InitFromInteriorSave(inst, save_data)
	inst.setUp(inst, save_data.wall_width, save_data.wall_rotation)
end


local function onsave(inst, data)
	if inst.wall_width then
		data.wall_width = inst.wall_width
	end
	if inst.wall_rotation then
		data.wall_rotation = inst.wall_rotation
	end

end

local function onload(inst, data)
	if data then
		if data.wall_width then
			inst.wall_width = data.wall_width
		end
		if data.wall_rotation then
			inst.wall_rotation = data.wall_rotation
		end
		setUp(inst,inst.wall_width,inst.wall_rotation)
	end
end


local function fn(Sim)
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()

	inst.AnimState:SetOrientation( ANIM_ORIENTATION.OnGround)   
	inst.Transform:SetScale(1,1,1)
	inst.Transform:SetNoFaced()
    inst:AddTag("structure")
    inst:AddTag("NOBLOCK")

    inst.setUp = setUp
	inst.initFromInteriorSave = InitFromInteriorSave
	
	--FPS -HAMLET CHANGE -CHANGE ROTATION BASED ON CAMERA MOVEMENT
	--[[
	inst:DoPeriodicTask(0, function(inst)
		if not (GetPlayer() and GetPlayer().FPSmode == true) then
			return end
			
		
		-- local cam_angle = GetPlayer().Transform:GetRotation() --TheCamera:GetHeadingTarget() * DEGREES
		local originrot = 90 --inst.wall_rotation or 0
		
		--DO ALL THAT COMPLEX CRAP THAT RE-ORIENTS WALLS TO THE CORRECT DIRECTION WHEN THE CAMERA IS ANGLED
		local function normalize(angle)
			while angle > 360 do
				angle = angle - 360
			end
			while angle < 0 do
				angle = angle + 360
			end
			return angle
		end


		local cam_angle = (TheCamera:GetHeading()%360) --TheCamera:GetHeadingTarget() --SAM THING BUT NONE OF THEM WORK
		-- cam_angle = normalize(180 - cam_angle)
		cam_angle = normalize(180 - (originrot + cam_angle))
		
		--LETS TRY SOMETHING ELSE. ALWAYS FACE WALL TOWARD PLAYER
		-- local ent_x, ent_y, ent_z = GetPlayer().Transform:GetWorldPosition()
		-- local cam_angle = inst:GetAngleToPoint(ent_x, ent_y, ent_z)
		-- cam_angle = normalize(180 - cam_angle) --CLOSE ENOUGH! :D
		
		
		-- inst.Transform:SetRotation(originrot + cam_angle)
		-- print("ROTATING WALL TO", (originrot + cam_angle))
		inst.Transform:SetRotation(45)
		print("ROTATING WALL TO", (cam_angle), cam_angle, originrot)
	end)
	]]--
	
	--ENOUGH!! WALLS DONT CANNOT BE ROTATED TO FACE ANY OTHER DIRECTION BUT THE PLAYER. THEY JUST CANT. 
	--WELL, IT SUCKS THAT WE HAVE TO SLAUGHTER THE ENTIRE PREFAB FILE JUST TO EDIT THE WIDTH FN AT THE VERY TOP, BUT I DON'T KNOW HOW ELSE TO EDIT A LOCAL FUNCTION 
	
    --------SaveLoad
    inst.OnSave = onsave 
    inst.OnLoad = onload 	

    return inst
end

return Prefab( "common/objects/generic_wall_back", fn, {}, {} )  
